#include <stdio.h>
#include <time.h>
#include <string.h>

#define INF (1 << 30)
#define MAXN 501

int N, M, nrmin = INF;
int A[MAXN][MAXN], ok[MAXN][MAXN], B[MAXN][MAXN];

int NUM;

void check(void);

void bkt(int x, int y, int nr)
{
	if(x == N+1)
	{
		check();
	}
	else
	{
		if(y == M+1)
			bkt(x+1, 1, nr);
		else
		{
			ok[x][y] = 0, bkt(x, y+1, nr), ok[x][y] = 1;
			if(nr+1 <= NUM)
				bkt(x, y+1, nr+1);
		}
	}
}

void check(void)
{
	int cnt = 0, i, j, k, okay = 1;
	memset(A, 0, sizeof(A));
	for(i = 1; i <= N; i++)
	 for(j = 1; j <= M; j++)
	 {
	 	for(k = 1; k <= j-1; k++)
			A[i][j] += ok[i][k];
		for(k = j+1; k <= M; k++)
			A[i][j] += ok[i][k];
		for(k = 1; k <= i-1; k++)
			A[i][j] += ok[k][j];
		for(k = i+1; k <= N; k++)
			A[i][j] += ok[k][j];
	 }
	for(i = 1; i <= N; i++)
	 for(j = 1; j <= M; j++)
	 {
	 	if(B[i][j] == 0 && A[i][j] % 2 == 1)
			okay = 0;
		if(B[i][j] == 1 && A[i][j] % 2 == 0)
			okay = 0;
		cnt += ok[i][j];
	 }
	if(okay == 1)
	 if(nrmin > cnt)
	 	nrmin = cnt;
}

int main(void)
{
	int i, j, cate = 0, t1, t2;

	freopen("becuri.in", "rt", stdin);
	freopen("becuri.out", "wt", stdout);

	t1 = clock();

	scanf("%d %d\n", &N, &M);

	for(i = 1; i <= N; i++)
	 for(j = 1; j <= M; j++)
	 	scanf("%d", &B[i][j]), cate += B[i][j];

	if(cate == 0)
	{
		printf("0\n");
		return 0;
	}

	if(cate == N*M && N == M)
	{
		printf("%d\n", N);
		return 0;
	}
		
	for(NUM = 0; NUM <= N*M; NUM++)
	{
		bkt(1, 1, 0);
		if(nrmin != INF)
		{
			printf("%d\n", nrmin);
			return 0;
		}
		t2 = clock();
		if( (double)((double)t2-t1)/CLK_TCK > 0.090000 )
		{	printf("-1\n"); return 0; }
	}

	return 0;
}




