#include <stdio.h>

FILE *f = fopen("team.in", "r");
FILE *g = fopen("team.out", "w");

long const nmax = 505; //501
long const pmax = 55; //51
long const inf = 1000000000;

long t1, t2, aux;
long p, n, m;
long v[nmax], dis[pmax][nmax], a[nmax][nmax]; //mat de adiacenta
long t[pmax][pmax][nmax];
long dest[nmax], edest[nmax][pmax];
//long taie[pmax], suma;

void citeste();
void dijkstra(long k, long *d);
long calct(long i, long j, long nod);

int main() {
	long sol;
	citeste();
	sol = calct(1, p, 1);
	fprintf(g, "%d\n", sol);
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i, j, k;

	fscanf(f, "%d%d%d", &p, &n, &m);
	for(i=1; i<=n; i++)
		for(j=1; j<=n; j++)
			a[i][j] = inf;
	for(i=1; i<=n; i++) a[i][i] = 0;

	for(i=1; i<=p; i++)
		for(j=1; j<=p; j++)
			for(k=1; k<=n; k++)
				t[i][j][k] = -1;

	for(i=1; i<=m; i++) {
		fscanf(f, "%d%d%d", &t1, &t2, &aux);
		a[t1][t2] = aux;
		a[t2][t1] = aux;
	}
	for(i=1; i<=p; i++) {
		fscanf(f, "%d", &(dest[i]));
		edest[ dest[i] ][0]++;
		edest[ dest[i] ][ edest[ dest[i] ][0] ] = i;
		dijkstra( dest[i], dis[i]);
	}
}

void dijkstra(long k, long *d) {
	long i, ul, nv, minim;

	for(i=1; i<=n; i++) {
		v[i] = 0;
		d[i] = inf;
	}

	nv = 0;
	ul = k;
	d[ul] = 0;
	while( 1==1) {
		//update
		v[ul] = 1;
		nv++;
		if(nv==n) return;
		for(i=1; i<=n; i++)
			if(v[i]==0 && d[i] > d[ul] + a[ul][i] )
				d[i] = d[ul] + a[ul][i];

		minim = inf;
		for(i=1; i<=n; i++)
			if(v[i]==0 && d[i] < minim) {
				ul = i;
				minim = d[i];
			}
	}
}

long calct(long i, long j, long nod) {
	long k, minim, temp, last, suma, taie[pmax];

	if(i > j) return 0;
	if( t[i][j][nod]>=0 ) return t[i][j][nod];
	if(i==j) {
		t[i][i][nod] = dis[i][nod];
		return t[i][i][nod];
	}

	taie[0] = 0;
	for(k=1; k<=edest[nod][0]; k++) {
		if(edest[nod][k] <=j && edest[nod][k] >=i) {
			taie[0]++;
			taie[taie[0]] = edest[nod][k];
		}
	}

	if(taie[0] > 0) {
		last = i;
		suma = 0;
		taie[0]++;
		taie[taie[0]] = j + 1;
		for(k=1; k<=taie[0]; k++) {
			suma += calct(last, taie[k] - 1, nod);
			last = taie[k] + 1;
		}
		t[i][j][nod] = suma;
	}
	else {
		minim = inf;
		for(k=i; k<=j; k++) {
			temp = calct(i, j, dest[k]) + dis[k][nod];
			if(minim > temp) minim = temp;
		}
		t[i][j][nod] = minim;
	}
	return t[i][j][nod];
}

