#include <stdio.h>

#define MAX_N 512
#define MAX_BUF 262144
#define INF 1000000666
#define FIN "becuri.in"
#define FOUT "becuri.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define MAX(a, b) ((a) > (b) ? (a) : (b))

int N, M, R[MAX_N], C[MAX_N], Res;
char A[MAX_N][MAX_N], buf[MAX_BUF], *p;

int solve(int x)
{
    int i, j, t, n[2], m[2];
    
    R[0] = x;
    FOR (i, 0, M) C[i] = A[0][i] ^ x;
    FOR (i, 1, N)
    {
        R[i] = A[i][0] ^ C[0];
        FOR (j, 1, M)
        {
            t = R[i] ^ C[j];
            if (t != A[i][j]) return INF;
        }
    }

    n[0] = n[1] = 0;
    FOR (i, 0, N) n[R[i]]++;
    m[0] = m[1] = 0;
    FOR (i, 0, M) m[C[i]]++;

    if ((n[1]&1) != (m[1]&1)) return INF;
    return MAX(n[1], m[1]);
}

inline int get(void) { p += 2; return *(p-2)-'0'; }

int main(void)
{
    int i, j, t;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d\n", &N, &M);
    FOR (i, 0, N)
    {
        fgets(buf, MAX_BUF, stdin);
        p = buf;
        FOR (j, 0, M) A[i][j] = get();
    }

    Res = INF;
    FOR (i, 0, 2)
    {
        t = solve(i);
        if (Res > t) Res = t;
    }

    printf("%d\n", Res == INF ? -1 : Res);
    
    return 0;
}
