#include <stdio.h>

int P, N, M;
int Cost[501][501];
int Grad[501];
int Vec [501][501];
int Dest[51];

int Mem[51][51][501];

int Este[501];
int Start,Stop;
int Coad[250001];
int Min[501][501];
int CalcMin[501];

int SOL;

int Parc(int i, int j, int pos){
	if (Mem[i][j][pos] != -1){
		return Mem[i][j][pos];
	}else{
		int a;
		if (!CalcMin[pos]){
			CalcMin[pos] = 1;
			int p;
			for(a=1;a<=N;a++){
				Min[pos][a] = 2000000000;
			}
			Start=Stop=1;
			Coad[1] = pos;
			int *min = Min[pos];
			min[pos] = 0;
			for(;Start<=Stop;Start++){
				p = Coad[Start];
				Este[p] = 0;
				for(a=1;a<=Grad[p];a++){
					if (min[Vec[p][a]] > min[p] + Cost[p][Vec[p][a]]){
						min[Vec[p][a]] = min[p] + Cost[p][Vec[p][a]];
						if (!Este[Vec[p][a]]){
							Este[Vec[p][a]] = 1;
							Coad[++Stop] = Vec[p][a];
						}
					}
				}
			}
		}
		if (i == j){
			return Mem[i][j][pos] = Min[pos][Dest[i]];
		}else{
			int sol;
			int tmp;
			sol = Min[pos][Dest[i]] + Parc(i+1, j, Dest[i]);
			tmp = Min[pos][Dest[j]] + Parc(i, j-1, Dest[j]);
			if (sol > tmp){
				sol = tmp;
			}
			for(a=i+1;a<j;a++){
				tmp = Min[pos][Dest[a]] + Parc(i, a-1, Dest[a]) + Parc(a+1, j, Dest[a]);
				if (sol > tmp){
					sol = tmp;
				}
			}
			return Mem[i][j][pos] = sol;
		}
	}
}

void Init(int P, int N){
	int a,b,c;
	for(a=1;a<=P;a++){
		for(b=a;b<=P;b++){
			for(c=1;c<=N;c++){
				Mem[a][b][c] = -1;
			}
		}
	}
	for(a=1;a<=N;a++){
		for(b=1;b<=N;b++) if (Cost[a][b] != -1){
			Vec[a][++Grad[a]] = b;
		}
	}
}

int STR0;
char STR[2000001];

int GET(void){
	int sol = 0;
	for(;!('0' <= STR[STR0] && STR[STR0] <= '9');STR0++);
	for(;'0' <= STR[STR0] && STR[STR0] <= '9';STR0++){
		sol *= 10;
		sol += STR[STR0]-48;
	}
	return sol;
}

int main(void){
	int a,b;
	int a1,a2,a3;
	FILE *e,*ee;
	e = fopen("team.in","r");
		fread(STR, 2000000, 1, e);
	fclose(e);
	P = GET();
	N = GET();
	M = GET();
	for(a=1;a<=N;a++){
		for(b=1;b<=N;b++){
			Cost[a][b] = -1;
		}
	}
	for(a=1;a<=M;a++){
		a1 = GET();
		a2 = GET();
		a3 = GET();
		Cost[a1][a2] = a3;
		Cost[a2][a1] = a3;
	}
	for(a=1;a<=P;a++){
		Dest[a] = GET();
	}
	Init(P, N);
	SOL = Parc(1, P, 1);
	ee = fopen("team.out", "w");
		fprintf(ee, "%d\n", SOL);
	fclose(ee);
}

