#include <cstdio>
#include <cstdlib>
#include <cstring>

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define CLEAR(X)     memset((X), 0, sizeof((X)))
#define INF          100000099

#define NMAX 505
int a[NMAX][NMAX];
int M, N, i, j;

void read(void)
{
    freopen("becuri.in", "r", stdin);
    freopen("becuri.out", "w", stdout);
    scanf("%d %d", &M, &N);
    FOR(i, 1, M)
        FOR(j, 1, N)
            scanf("%d", &a[i][j]);
}
int get_ans(int i, int j)
{
    if ((i + j) & 1)
        return INF;
    else
        return i > j ? i : j;
}

#define MIN(a, b) ((a) < (b) ? (a) : (b))
void solve(void)
{
    int same, diff, L = 0, C = 0;
    
    FOR(i, 2, M)
    {
        same = diff = 0;
        FOR(j, 1, N)
            if (a[i][j] == a[1][j]) ++ same; else ++ diff;
        if (same > 0 && diff > 0) { printf("-1\n"); return; }
        if (diff) ++ L;
    }
    FOR(j, 1, N) C += a[1][j];

    if (((L + C) & 1) && ((M - L + N - C) & 1)) { printf("-1\n"); return; }
    int Ans1 = get_ans(L, C);
    int Ans2 = get_ans(M - L, N - C);
    printf("%d\n", MIN(Ans1, Ans2));
}

int main(void)
{
    read();
    solve();
    return 0;
}
