#include <stdio.h>
#include <string.h>
#define nmax 511
#define pmax 55
#define mmax 101100
#define inf 500111000

int n,m,p,z,nr[mmax],urm[mmax],v[nmax],ct[mmax],D[pmax],aux[nmax];
int a[nmax][pmax][pmax],viz[nmax],min[nmax][nmax];

void Vadd(int i,int j,int c)
{
  urm[++z]=v[i];
  v[i]=z, nr[z]=j, ct[z]=c;
}

void dijkstra(int s)
{
  int ii,j,i;
  for(i=1;i<=n;++i)
    aux[i]=inf;
  memset(viz,0,sizeof(viz));
  for(aux[s]=0,ii=1;ii<n;++ii)
  {
    for(j=1,i=2;i<=n;++i)
      if(!viz[i]&&(viz[j]||(aux[i]<aux[j])))
	  j=i;
    viz[j]=1;
    for(i=v[j];i;i=urm[i])
      if(aux[nr[i]]>aux[j]+ct[i])
	aux[nr[i]]=aux[j]+ct[i];
  }
  memcpy(min[s],aux,sizeof(aux));
}

int MIN(int x,int y)
{
  return(x<y?x:y);
}

int doit(int x,int i,int j)
{
  int ii,aux;  
  if(a[x][i][j]==-1)
  {
    for(ii=i;ii<=j;++ii)
      if(D[ii]==x)
	return(a[x][i][j]=doit(x,i,ii-1)+doit(x,ii+1,j));
    aux=inf;
    for(ii=i;ii<=j;++ii)
      aux=MIN(aux,min[x][D[ii]]+doit(D[ii],i,j));
    a[x][i][j]=aux;
  }
  return(a[x][i][j]);    
}

int main()
{
  FILE *fi=fopen("team.in","r"),*fo=fopen("team.out","w");
  fscanf(fi,"%d",&p);
  fscanf(fi,"%d",&n);
  fscanf(fi,"%d",&m);
  int ii,i,j,ct;
  for(ii=1;ii<=m;++ii)
  {
    fscanf(fi,"%d %d %d",&i,&j,&ct);
    Vadd(i,j,ct);
    Vadd(j,i,ct);
  }       
  for(i=1;i<=p;++i)
    fscanf(fi,"%d",&D[i]);        
  fclose(fi);
  for(ii=1;ii<=n;++ii)
    for(i=1;i<=p;++i)
      for(j=i;j<=p;++j)
	a[ii][i][j]=-1;
  for(D[i=0]=1;i<=p;++i)
    dijkstra(D[i]);
  fprintf(fo,"%d\n",doit(1,1,p));
  fclose(fo);
  return(0);
}
