const maxN = 510;

var a, b: array[0..maxN, 0..maxN] of longint;
    i, j, n, m, best, h, w, max: longint;
    error: boolean;

procedure read_data;
var f: text;
begin

 assign(f, 'becuri.in'); reset(f);

  readln(f, n, m);
  for i := 1 to n do begin
   for j := 1 to m do read(f, a[i, j]);
   readln(f);
  end;

 close(f);

end;

procedure main;
begin

 best := 333333;

 // Cazul I ( - sus )
 fillchar(b, sizeof(b), 0);
 max := 0; w := 0; h := 0; error := false;
 for j := 1 to m do
  if a[1, j] = 1 then begin
   for i := 1 to n do inc(b[i, j]);
   inc(w);
  end;

 for i := 1 to n do
  if b[i, 1] mod 2 <> a[i, 1] then begin
   for j := 1 to m do inc(b[i, j]);
   inc(h);
  end;

 for i := 1 to n do
  for j := 1 to m do
   if b[i, j] mod 2 <> a[i, j] then begin
      error := true;
      break;
   end;

 if h > w then max := h else max := w;
 if (not error) and (abs(w - h) mod 2 = 0) and (best > max) then best := max;

 // Cazul II ( | stanga )
 fillchar(b, sizeof(b), 0);
 max := 0; w := 0; h := 0; error := false;
 for i := 1 to n do
  if a[i, 1] = 1 then begin
   for j := 1 to m do inc(b[i, j]);
   inc(h);
  end;

 for j := 1 to m do
  if b[1, j] mod 2 <> a[1, j] then begin
   for i := 1 to n do inc(b[i, j]);
   inc(w);
  end;

 for i := 1 to n do
  for j := 1 to m do
   if b[i, j] mod 2 <> a[i, j] then begin
      error := true;
      break;
   end;

 if h > w then max := h else max := w;
 if (not error) and (abs(w - h) mod 2 = 0) and (best > max) then best := max;

 // Cazul III ( - jos )
 fillchar(b, sizeof(b), 0);
 max := 0; w := 0; h := 0; error := false;
 for j := 1 to m do
  if a[n, j] = 1 then begin
   for i := 1 to n do inc(b[i, j]);
   inc(w);
  end;

 for i := 1 to n do
  if b[i, 1] mod 2 <> a[i, 1] then begin
   for j := 1 to m do inc(b[i, j]);
   inc(h);
  end;

 for i := 1 to n do
  for j := 1 to m do
   if b[i, j] mod 2 <> a[i, j] then begin
      error := true;
      break;
   end;

 if h > w then max := h else max := w;
 if (not error) and (abs(w - h) mod 2 = 0) and (best > max) then best := max;

 // Cazul IV ( | dreapta )
 fillchar(b, sizeof(b), 0);
 max := 0; w := 0; h := 0; error := false;
 for i := 1 to n do
  if a[i, m] = 1 then begin
   for j := 1 to m do inc(b[i, j]);
   inc(h);
  end;

 for j := 1 to m do
  if b[1, j] mod 2 <> a[1, j] then begin
   for i := 1 to n do inc(b[i, j]);
   inc(w);
  end;

 for i := 1 to n do
  for j := 1 to m do
   if b[i, j] mod 2 <> a[i, j] then begin
      error := true;
      break;
   end;

 if h > w then max := h else max := w;
 if (not error) and (abs(w - h) mod 2 = 0) and (best > max) then best := max;

end;

procedure write_data;
var g: text;
begin

 assign(g, 'becuri.out'); rewrite(g);

  if best = 333333 then writeln(g, '-1') else
                        writeln(g, best);

 close(g);

end;

begin

 read_data;
 main;
 write_data;

end.