#include <stdio.h>

#define NMAX 501
#define PMAX 54

FILE *fin,*fout;
int P,N,M;
int dest[NMAX+1];
struct Nod
{int v,c;
 Nod *leg;
}*gr[NMAX+1];
struct sheap
{int v;
 long c;
}h[NMAX+1];
int lh,o[NMAX+1];
long cf[NMAX+1];
int s[NMAX+1];
int mark[NMAX+1];
long cost[PMAX+1][PMAX+1][PMAX+1];
long dist[PMAX+2][NMAX+1];
long dist2[PMAX+2][PMAX+2];
int nr[NMAX+2],t,ind[NMAX+2];
long cc[PMAX+1][PMAX+1];
const long pin=1000000000;

void add_edge(int x,int y,int z)
{Nod *p;
 p=new Nod;p->v=y;p->c=z;p->leg=gr[x];gr[x]=p;
}

void insert_heap(int cv,long cd)
{int vf,baza;
 sheap val;
 ++lh;
 h[lh].v=cv;h[lh].c=cd;
 val=h[lh];vf=lh;
 for (baza=lh/2;baza>0;baza/=2)
	 {if (val.c<h[baza].c)
		 {h[vf]=h[baza];o[h[vf].v]=vf;vf=baza;}
	  else break;
	 }
 h[vf]=val;
 o[h[vf].v]=vf;
}
void pop_heap()
{int vf,baza;
 sheap val;
 s[h[1].v]=1;
 if (lh==1) --lh;
 else {h[1]=h[lh];--lh;
	   val=h[1];vf=1;
	   for (baza=vf*2;baza<=lh;baza<<=1)
		   {if (baza<lh&&h[baza].c>h[baza+1].c) ++baza;
			if (val.c>h[baza].c)
			   {h[vf]=h[baza];o[h[vf].v]=vf;vf=baza;}
			else break;
		   }
	   h[vf]=val;
	   o[h[vf].v]=vf;
	  }
}
void urca(int vf)
{int baza;
 sheap val;
 val=h[vf];
 for (baza=vf/2;baza>0;baza/=2)
	 {if (val.c<h[baza].c)
		 {h[vf]=h[baza];o[h[vf].v]=vf;vf=baza;}
	  else break;
	 }
 h[vf]=val;
 o[h[vf].v]=vf;
}

void rebuild()
{int i,j,cv,k;
 Nod *p;
 for (i=1;i<=N;++i)
	 mark[i]=0;
 for (i=1;i<=P;++i)
	 mark[dest[i]]=1;
 for (i=1;i<=N;++i)
	if (mark[i])
	  {nr[++t]=i;ind[i]=t;
	   lh=0;
	   for (j=1;j<=N;++j)
		   {s[j]=0;
			if (j!=i)
			   insert_heap(j,pin);
			else insert_heap(j,0);
		   }
		while (lh>0)
			{cv=h[1].v;
			 dist[t][cv]=h[1].c;
			 pop_heap();
			 for (p=gr[cv];p;p=p->leg)
				 if (!s[p->v]&&h[o[p->v]].c>dist[t][cv]+p->c)
					{h[o[p->v]].c=dist[t][cv]+p->c;
					 urca(o[p->v]);
					}
			}
	  }
 for (i=1;i<=t;++i)
	 {k=0;
	  for (j=1;j<=N;++j)
		if (mark[j]) dist2[i][++k]=dist[i][j];
	 }
}

long opt_taie(int *lista,int nl,int nod)
{int i,j,k,lat,l1,l2,cost1,cost2;
 for (j=2;j<=nl;++j)
   for (i=1;i<=nl-j+1;++i)
	   {if (j==2)
		   {if (lista[i]+1<=lista[i+j-1]-1)
			  {lat=lista[i+j-1]-1-lista[i];
			   cc[i][j]=cost[lista[i]+1][lat][nod];
			  }
			else cc[i][j]=0;
		   }
		else {lat=lista[i+j-1]-1-lista[i];
			  if (j<nl) cc[i][j]=cost[lista[i]+1][lat][nod];
			  else cc[i][j]=pin;
			  for (k=i+1;k<i+j-1;++k)
				 {l1=lista[k]-1-lista[i];
				  if (l1<0) cost1=0;
				  else cost1=cc[i][k-i+1];
				  l2=lista[i+j-1]-1-lista[k];
				  if (l2<0) cost2=0;
				  else cost2=cc[k][i+j-k];
				  if (cc[i][j]>cost1+cost2)
					 cc[i][j]=cost1+cost2;
				 }
			 }
	   }
 return cc[1][nl];
}

void constr(int cs,int cd)
{int i,j,cv,lista[PMAX+3],nl;
 for (i=1;i<=t;++i) mark[i]=0;
 for (i=cs;i<=cd;++i)
	 mark[ind[dest[i]]]=1;
 for (i=1;i<=t;++i)
	if (mark[i])
	   {nl=0;lista[++nl]=cs-1;
		for (j=cs;j<=cd;++j)
		   if (ind[dest[j]]==i) lista[++nl]=j;
		lista[++nl]=cd+1;
		cost[cs][cd-cs+1][i]=opt_taie(lista,nl,i);
	   }
 for (i=1;i<=t;++i) s[i]=0;
 lh=0;
 for (i=1;i<=t;++i)
	if (mark[i]) insert_heap(i,cost[cs][cd-cs+1][i]);
	else insert_heap(i,pin);
 while (lh>0)
	 {cv=h[1].v;
	  cf[cv]=h[1].c;
	  pop_heap();
	  for (i=1;i<=t;++i)
		 if (!s[i]&&h[o[i]].c>cf[cv]+dist2[cv][i])
			{h[o[i]].c=cf[cv]+dist2[cv][i];
			 urca(o[i]);
			}
	 }
 for (i=1;i<=t;++i)
   cost[cs][cd-cs+1][i]=cf[i];
}

int main()
{int i,j,x,y,z;
 fin=fopen("team.in","r");
 fscanf(fin,"%d",&P);
 fscanf(fin,"%d",&N);
 fscanf(fin,"%d",&M);
 for (i=1;i<=M;++i)
	 {fscanf(fin,"%d %d %d",&x,&y,&z);
	  add_edge(x,y,z);
	  add_edge(y,x,z);
	 }
 for (i=1;i<=P;++i)
	 fscanf(fin,"%d",&dest[i]);
 fclose(fin);
 ++P;dest[P]=1;
 rebuild();
 for (j=1;j<=P;++j)
	for (i=1;i<=P-j+1;++i)
		constr(i,i+j-1);
 fout=fopen("team.out","w");
 fprintf(fout,"%ld\n",cost[1][P][1]);
 fclose(fout);
 return 0;
}
