#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
FILE *fin,*fout;
clock_t start,end;
int m,n,count0=0,count1=0;
short int a[505][505],b[505][505];

inline double timp(clock_t start, clock_t end)
  {return ((double)(end-start))/CLOCKS_PER_SEC;}

void citire()
  {int i,j;
   fin=fopen("becuri.in","r");
   fscanf(fin,"%d %d",&m,&n);
   for(i=0;i<m;i++)
      for(j=0;j<n;j++)
         fscanf(fin,"%d",&a[i][j]);
   fclose(fin);}

void scrie_solutie(int sol)
  {fout=fopen("becuri.out","w");
   fprintf(fout,"%d\n",sol);
   fclose(fout);
   exit(0);}

inline void act_comutator(int poz, int &count0, int &count1)
  {int lin=poz/n;
   int col=poz%n;
   int i;
   for(i=0;i<m;i++)
      if(i!=lin)
        if(b[i][col]==0)
          {count0--;
           count1++;
           b[i][col]=1;}
        else
          {count1--;
           count0++;
           b[i][col]=0;}
   for(i=0;i<n;i++)
      if(i!=col)
        if(b[lin][i]==0)
          {count0--;
           count1++;
           b[lin][i]=1;}
        else
          {count1--;
           count0++;
           b[lin][i]=0;}}

inline void copiaza_b()
  {for(int i=0;i<m;i++)
      for(int j=0;j<n;j++)
         b[i][j]=a[i][j];}
  

int main()
{
int i,j,k,l,p,q,r,s;
int found=0,max,c0,c1;
start=clock();
citire();
for(i=0;i<m;i++)
   for(j=0;j<n;j++)
      if(a[i][j])
        {found=1;
         count1++;}
      else
        count0++;
if(!found)
  scrie_solutie(0);
max=m*n;
end=clock();
// se actioneaza un comutator
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    if(!c1)
      scrie_solutie(1);
    end=clock();}
// se actioneaza 2 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    if(!c1)
      scrie_solutie(2);
    end=clock();}
// se actioneaza 3 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    if(!c1)
      scrie_solutie(3);
    end=clock();}
// se actioneaza 4 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
for(l=k+1;(l<max)&&timp(start,end)<0.095;l++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    act_comutator(l,c0,c1);
    if(!c1)
      scrie_solutie(4);
    end=clock();}
// se actioneaza 5 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
for(l=k+1;(l<max)&&timp(start,end)<0.095;l++)
for(p=l+1;(p<max)&&timp(start,end)<0.095;p++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    act_comutator(l,c0,c1);
    act_comutator(p,c0,c1);
    if(!c1)
      scrie_solutie(5);
    end=clock();}        
// se actioneaza 6 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
for(l=k+1;(l<max)&&timp(start,end)<0.095;l++)
for(p=l+1;(p<max)&&timp(start,end)<0.095;p++)
for(q=p+1;(q<max)&&timp(start,end)<0.095;q++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    act_comutator(l,c0,c1);
    act_comutator(p,c0,c1);
    act_comutator(q,c0,c1);
    if(!c1)
      scrie_solutie(6);
    end=clock();}
// se actioneaza 7 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
for(l=k+1;(l<max)&&timp(start,end)<0.095;l++)
for(p=l+1;(p<max)&&timp(start,end)<0.095;p++)
for(q=p+1;(q<max)&&timp(start,end)<0.095;q++)
for(r=q+1;(r<max)&&timp(start,end)<0.095;r++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    act_comutator(l,c0,c1);
    act_comutator(p,c0,c1);
    act_comutator(q,c0,c1);
    act_comutator(r,c0,c1);
    if(!c1)
      scrie_solutie(7);
    end=clock();}
// se actioneaza 8 comutatoare
for(i=0;(i<max)&&timp(start,end)<0.095;i++)
for(j=i+1;(j<max)&&timp(start,end)<0.095;j++)
for(k=j+1;(k<max)&&timp(start,end)<0.095;k++)
for(l=k+1;(l<max)&&timp(start,end)<0.095;l++)
for(p=l+1;(p<max)&&timp(start,end)<0.095;p++)
for(q=p+1;(q<max)&&timp(start,end)<0.095;q++)
for(r=q+1;(r<max)&&timp(start,end)<0.095;r++)
for(s=r+1;(s<max)&&timp(start,end)<0.095;s++)
   {copiaza_b();
    c0=count0;
    c1=count1;
    act_comutator(i,c0,c1);
    act_comutator(j,c0,c1);
    act_comutator(k,c0,c1);
    act_comutator(l,c0,c1);
    act_comutator(p,c0,c1);
    act_comutator(q,c0,c1);
    act_comutator(r,c0,c1);
    act_comutator(s,c0,c1);
    if(!c1)
      scrie_solutie(8);
    end=clock();}                
scrie_solutie(-1);
return 0;
}
