#include <stdio.h>

#define MAXN 2001099

void read(void);
void solve(int dx, int dy);

int M, N, A, B, line[MAXN][2], st1[MAXN], st2[MAXN];
long long rez = 0;

int main(void)
{
	freopen("drept.in", "r", stdin);
    freopen("drept.out", "w", stdout);

    read();

    solve(A, B);
    if (A != B)
    	solve(B, A);

    printf("%lld\n", rez);

    return 0;
}

void read(void)
{
	int i;

	scanf("%d %d %d %d", &M, &N, &A, &B);

    for (i = 0; i < N; i++)
    	scanf("%d %d", &line[i][0], &line[i][1]), line[i][1] = line[i][0] + line[i][1] - 1;
}

void solve(int dx, int dy)
{
	int b1 = 0, e1 = -1, b2 = 0, e2 = -1, i, min, max;

    for (i = 0; i < N; i++)
    {
		while (e1 >= b1 && line[i][0] >= line[st1[e1]][0]) e1--;
        st1[++e1] = i;
        while (e2 >= b2 && line[i][1] <= line[st2[e2]][1]) e2--;
        st2[++e2] = i;
        while (i - st1[b1] + 1 > dx) b1++;
        while (i - st2[b2] + 1 > dx) b2++;

        if (i >= dx - 1)
        {
        	min = line[st1[b1]][0];
            max = line[st2[b2]][1];
            if (max - min + 1 >= dy)
            	rez += max - min + 1 - dy + 1;
        }
    }
}
