#include <stdio.h>

#define MAX_N 2000200
#define MAX_BUF 65536
#define FIN "drept.in"
#define FOUT "drept.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define ll long long

int N, M, A, B, L[MAX_N], R[MAX_N];
int min_ql, min_qr, max_ql, max_qr, min_val[MAX_N], min_pos[MAX_N], max_val[MAX_N], max_pos[MAX_N];
char buf[MAX_BUF], *p;

inline int get(void)
{
    int n;
    
    for (n = 0; *p >= '0' && *p <= '9'; p++)
        n = n*10 + *p-'0';
    p++;
    return n;
}

ll solve(int a, int b)
{
    int i, t; ll ret = 0;

    min_ql = max_ql = 0;
    min_qr = max_qr = -1;
    FOR (i, 0, N)
    {
        t = L[i];
        for (; max_ql <= max_qr && max_val[max_qr] <= t; max_qr--);
        for (; max_ql <= max_qr && max_pos[max_ql] <= i-a; max_ql++);
        max_pos[++max_qr] = i; max_val[max_qr] = t;

        t = R[i];
        for (; min_ql <= min_qr && min_val[min_qr] >= t; min_qr--);
        for (; min_ql <= min_qr && min_pos[min_ql] <= i-a; min_ql++);
        min_pos[++min_qr] = i; min_val[min_qr] = t;

        t = min_val[min_ql]-max_val[max_ql]+1;
        if (t >= b && i >= a-1)
            ret += (ll) t-b+1;
    }
    return ret;
}

int main(void)
{
    int i;
    ll res;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);
    
    scanf("%d %d %d %d\n", &M, &N, &A, &B);
    FOR (i, 0, N)
    {
        fgets(buf, MAX_BUF, stdin);
        p = buf; L[i] = get(); R[i] = L[i]+get()-1;
    }

    res = solve(A, B) + (A != B) * solve(B, A);
    printf("%lld\n", res);
    
    return 0;
}
