// sursa busita :(
#include <stdio.h>
#include <string.h>

#define MAX_N 40
#define FIN "gard.in"
#define FOUT "gard.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define INF 1000000666

const int di[] = {+1,-1, 0, 0,+1,-1,+1,-1};
const int dj[] = { 0, 0,+1,-1,+1,-1,-1,+1};

int N, M, X[8], Y[8], nr, A[MAX_N][MAX_N], bst1[MAX_N][MAX_N], bst2[MAX_N][MAX_N], Res;
int D[MAX_N][MAX_N][MAX_N][MAX_N], set_cost[1<<5][MAX_N][MAX_N], bst[1<<5][MAX_N][MAX_N];

void baga_mare(int bst[MAX_N][MAX_N], int cost[MAX_N][MAX_N], int sx, int sy)
{
    int i, j, ii, jj, ok, d;

    FOR (i, 0, N) FOR (j, 0, N) bst[i][j] = INF;
    bst[sx][sy] = cost[sx][sy];

    for (ok = 1; ok; )
    {
        ok = 0;
        FOR (i, 0, N) FOR (j, 0, N)
        {
            if (bst[i][j] == INF) continue;
            FOR (d, 0, 8)
            {
                ii = i+di[d]; jj = j+dj[d];
                if (ii < 0 || jj < 0 || ii >= N || jj >= N) continue;
                if (bst[ii][jj] > bst[i][j]+cost[ii][jj])
                   bst[ii][jj] = bst[i][j]+cost[ii][jj], ok = 1;
            }
        }
    }
}

int solve(int set, int x, int y)
{
    int i, j, t, Res = INF, C[MAX_N][MAX_N];
    int min_x = INF, min_y = INF, max_x = -INF, max_y = -INF;

    FOR (i, 0, nr)
    {
        if (!(set & (1<<i))) continue;
        min_x = MIN(min_x, X[i]); min_y = MIN(min_y, Y[i]);
        max_x = MAX(max_x, X[i]); max_y = MAX(max_y, Y[i]);
    }
    
    if (x < min_x || x > max_x)
    {
        memcpy(C, A, sizeof(A));
        FOR (i, 0, nr)
        {
            if (!(set & (1<<i))) continue;
            FOR (j, Y[i], N) C[X[i]][j] = INF;
        }
        baga_mare(bst1, C, x, y);

        memcpy(C, A, sizeof(A));
        FOR (i, 0, nr)
        {
            if (!(set & (1<<i))) continue;
            FOR (j, 0, Y[i]) C[X[i]][j] = INF;
        }
        baga_mare(bst2, C, x, y);

        if (x < min_x)
        {
            FOR (i, max_x+1, N) FOR (j, 0, N)
            {
                if (A[i][j] == INF) continue;
                t = bst1[i][j] + bst2[i][j] - A[x][y] - A[i][j];
                Res = MIN(Res, t);
            }
        }
        else
        {
            FOR (i, 0, min_x) FOR (j, 0, N)
            {
                if (A[i][j] == INF) continue;
                t = bst1[i][j] + bst2[i][j] - A[x][y] - A[i][j];
                Res = MIN(Res, t);
            }
         }
    }

    if (y < min_y || y > max_y)
    {
        memcpy(C, A, sizeof(A));
        FOR (i, 0, nr)
        {
            if (!(set & (1<<i))) continue;
            FOR (j, X[i], N) C[j][Y[i]] = INF;
        }
        baga_mare(bst1, C, x, y);

        memcpy(C, A, sizeof(A));
        FOR (i, 0, nr)
        {
            if (!(set & (1<<i))) continue;
            FOR (j, 0, X[i]) C[j][Y[i]] = INF;
        }
        baga_mare(bst2, C, x, y);

        if (y < min_y)
        {
            FOR (j, 0, N) FOR (i, max_y+1, N)
            {
                if (A[j][i] == INF) continue;
                t = bst1[j][i] + bst2[j][i] - A[x][y] - A[j][i];
                Res = MIN(Res, t);
            }
        }
        else
        {
            FOR (j, 0, N) FOR (i, 0, min_y)
            {
                if (A[j][i] == INF) continue;
                t = bst1[j][i] + bst2[j][i] - A[x][y] - A[j][i];
                Res = MIN(Res, t);
            }
         }
    }

    return Res;
}

int main(void)
{
    int i, j, x, y, xx, yy, t;
 
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d", &N);
    FOR (i, 0, N) FOR (j, 0, N)
    {
        scanf("%d", A[i]+j);
        if (A[i][j] == -1)
        {
            A[i][j] = INF;
            X[nr] = i; Y[nr++] = j;
        }
    }

    FOR (i, 0, N) FOR (j, 0, N)
        baga_mare(D[i][j], A, i, j);
	    
    FOR (i, 1, (1<<nr)) FOR (x, 0, N) FOR (y, 0, N)
        set_cost[i][x][y] = solve(i, x, y);

    FOR (i, 1, (1<<nr)) FOR (x, 0, N) FOR (y, 0, N)
    {
        bst[i][x][y] = set_cost[i][x][y];
        FOR (j, 1, (1<<nr))
        {
            if ((i & j) != j || i == j) continue;
            FOR (xx, 0, N) FOR (yy, 0, N)
            {
                if (bst[i-j][xx][yy] == INF || set_cost[j][x][y] == INF) continue;
                t = bst[i-j][xx][yy] + set_cost[j][x][y] + D[xx][yy][x][y] - A[xx][yy] - (x != xx || y != yy)*A[x][y];
                if (bst[i][x][y] > t) bst[i][x][y] = t;
            }
        }
    }

    Res = INF;
    FOR (x, 0, N) FOR (y, 0, N)
        Res = MIN(Res, bst[(1<<nr)-1][x][y]);

    printf("%d\n", Res);

    return 0;
}
