#include <stdio.h>

#define FIN "drept.in"
#define FOUT "drept.out"

#define MAX_N 2000101

int A, B, N, M, Left[MAX_N], Right[MAX_N], Q[MAX_N], q[MAX_N];
long long rectangles;

long long count(void)
{
    long long cnt = 0ll;
    int i, ql, qr, Ql, Qr;

    Ql = ql = 0;
    Qr = qr = -1;
    for (i = 1; i <= N; i++)
    {
        if (i - Q[Ql] >= A)
           Ql++;
        if (i - q[ql] >= A)
           ql++;
        for (; qr >= ql && Left[i] > Left[q[qr]]; qr--) ;
        for (; Qr >= Ql && Right[i] < Right[Q[Qr]]; Qr--) ;
        Q[++Qr] = i, q[++qr] = i;
        if (i >= A)
           if (Right[Q[Ql]] - Left[q[ql]] + 1 >= B)
              cnt += (long long) (((long long) Right[Q[Ql]]) - ((long long) Left[q[ql]]) - ((long long) (B)) + 2ll);
    }

    return cnt;
}

int main(void)
{
    int i;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d %d %d", &M, &N, &A, &B);
    for (i = 1; i <= N; i++)
    {
        scanf("%d %d", Left + i, Right + i);
        if (!Right[i])
           Left[i] = M + 1, Right[i] = 0;
        else Right[i] += Left[i] - 1;
    }

    if (A == B)
       rectangles = count();
    else
    {
        rectangles = count();
        A = (A ^ B) ^ (B  = A);
        rectangles = (long long) (rectangles + count());
    }

    printf("%lld\n", rectangles);

    return 0;
}
