#include <stdio.h>

int M, N, A, B;

long long SOL;
int L1[2000100];
int L2[2000100];

int Max [2000100];
int MaxP[2000100];
int MaxFirst,MaxLast,MaxStart,MaxStop;
int Min [2000100];
int MinP[2000100];
int MinFirst,MinLast,MinStart,MinStop;

void MaxInit(void){
	MaxFirst = 1;
	MaxLast = 0;
	MaxStart = 1;
	MaxStop = 0;
}

void MaxAdd(int val){
	int pos;
	MaxLast++;
	MaxStop++;
	MaxP[MaxStop] = MaxLast;
	Max [MaxStop] = val;
	for(pos=MaxStop;pos>MaxStart && Max[pos]>Max[pos-1];pos--){
		MaxP[pos-1] = MaxP[pos];
		Max [pos-1] = Max [pos];
	}
	MaxStop = pos;
}

int MaxGet(void){
	return Max[MaxStart];
}

void MaxRem(void){
	if (MaxFirst==MaxP[MaxStart]) MaxStart++;
	MaxFirst++;
}

void MinInit(void){
	MinFirst = 1;
	MinLast = 0;
	MinStart = 1;
	MinStop = 0;
}

void MinAdd(int val){
	int pos;
	MinLast++;
	MinStop++;
	MinP[MinStop] = MinLast;
	Min [MinStop] = val;
	for(pos=MinStop;pos>MinStart && Min[pos]<Min[pos-1];pos--){
		MinP[pos-1] = MinP[pos];
		Min [pos-1] = Min [pos];
	}
	MinStop = pos;
}

int MinGet(void){
	return Min[MinStart];
}

void MinRem(void){
	if (MinFirst==MinP[MinStart]) MinStart++;
	MinFirst++;
}

long long Solve(void){
	long long sol=0;
	int min,max;
	int a;
	MaxInit();
	MinInit();
	for(a=1;a<A && a<=N;a++){
		MaxAdd(L1[a]);
		MinAdd(L2[a]);
	}
	for(;a<=N;a++){
		MaxAdd(L1[a]);
		MinAdd(L2[a]);
		min = MaxGet();
		max = MinGet();
		if (max-min+2-B > 0) sol += max-min+2-B;
		MaxRem();
		MinRem();
	}
	return sol;
}

int main(void){
	int a;
	int a1,a2;
	int a10,a20,a11,a21,a12,a22,a13,a23,a14,a24;
	int tmp;
	FILE *e,*ee;
	e = fopen("drept.in","r");
		fscanf(e, "%d %d %d %d", &M, &N, &A, &B);
		for(a=1;a+5<=N;a+=5){
			fscanf(e, "%d %d %d %d %d %d %d %d %d %d", &a10, &a20, &a11, &a21, &a12, &a22, &a13, &a23, &a14, &a24);
			L1[a  ] = a10;
			L2[a  ] = a10+a20-1;
			L1[a+1] = a11;
			L2[a+1] = a11+a21-1;
			L1[a+2] = a12;
			L2[a+2] = a12+a22-1;
			L1[a+3] = a13;
			L2[a+3] = a13+a23-1;
			L1[a+4] = a14;
			L2[a+4] = a14+a24-1;
		}
		for(;a<=N;a++){
			fscanf(e, "%d %d", &a1, &a2);
			L1[a] = a1;
			L2[a] = a1+a2-1;
		}
	fclose(e);
	SOL = Solve();
	tmp = A;
	A = B;
	B = tmp;
	SOL+= Solve();
	ee = fopen("drept.out","w");
		fprintf(ee, "%lld\n", SOL);
	fclose(ee);
	return 0;
}

