#include <stdio.h>
#include <stdlib.h>

typedef struct Tip{
	int X;
	int Y;
	Tip *Ante;
	Tip *Urm;
}Tip;

typedef struct Point{
	int X;
	int Y;
}Point;

Point Mut[4]={
	{-1, 0},
	{ 0,-1},
	{ 0, 1},
	{ 1, 0}
};

int N;
int Q[40][40];

Tip *Una;

int SOL;

int Add(int a, int b){
	Tip *p;
	p = Una;
	Una = (Tip*)malloc(sizeof(Tip));
	Una->X = a;
	Una->Y = b;
	Una->Ante = NULL;
	Una->Urm = p;
	if (p) p->Ante = Una;
}

void Init(void){
	int a;
	Tip *p;
	Una = NULL;
	for(a=2;a<N;a++){
		Add(1, a);
	}
	for(a=2;a<N;a++){
		Add(a, N);
	}
	for(a=N-1;a>1;a--){
		Add(N, a);
	}
	for(a=N-1;a>1;a--){
		Add(a, 1);
	}
	for(p=Una;p->Urm;p=p->Urm);
	Una->Ante = p;
	p->Urm = Una;
}

void Solve(void){
	Tip *p,*q,*r;
	int z;
	int a;
	int X,Y;
	int nX,nY;
	int mut,opt;
	p = Una;
	for(z=1;z<=100000;z++){
		//mutarea
		X = p->X;
		Y = p->Y;
		mut = -1;
		opt = -1;
		for(a=0;a<4;a++){
			nX = X+Mut[a].X;
			nY = Y+Mut[a].Y;
			if (1 <= nX && nX <= N && 1 <= nY && nY <= N)
			if (Q[nX][nY] !=-1 && Q[nX][nY] <= Q[X][Y]){
				if (abs(nX-p->Urm->X)<=1 && abs(nY-p->Urm->Y)<=1 && (!(nX==p->Urm->X && nY==p->Urm->Y)) &&
					abs(nX-p->Ante->X)<=1 && abs(nY-p->Ante->Y)<=1 && (!(nX==p->Ante->X && nY==p->Ante->Y))){
					if (opt < Q[X][Y] - Q[nX][nY]){
						opt = Q[X][Y] - Q[nX][nY];
						mut = a;
					}
				}
			}
		}
		if (mut != -1){
			p->X += Mut[mut].X;
			p->Y += Mut[mut].Y;
		}
		//disparitia
		if (abs(p->Ante->X-p->Urm->X)<=1 && abs(p->Ante->Y-p->Urm->Y)<=1){
			q = p->Ante;
			r = p->Urm;
			q->Urm = r;
			r->Ante = q;
			if (Una == p) Una = q;
			free(p);
			p=q;
		}
		p=p->Urm;
	}
}

int Calc(void){
	Tip *p=Una;
	int sol;
	sol = Q[p->X][p->Y];
	for(p=Una->Urm;p!=Una;p=p->Urm){
		sol += Q[p->X][p->Y];
	}
	return sol;
}

int main(void){
	int a,b;
	FILE *e,*ee;
	e = fopen("gard.in","r");
		fscanf(e, "%d", &N);
		for(a=1;a<=N;a++){
			for(b=1;b<=N;b++){
				fscanf(e, "%d", &Q[a][b]);
			}
		}
	fclose(e);
	Init();
	Solve();
	SOL = Calc();
	ee = fopen("gard.out","w");
		fprintf(ee, "%d\n", SOL);
	fclose(ee);
	return 0;
}

