#include <cstdio>
#include <cstring>

#define FIN "gard.in"
#define FOUT "gard.out"
#define MX 50
#define INF 100000


long long CO=0;

long n, a[MX][MX], p[7][2];
char marc[MX][MX];
long i, j, nr;


void read_data()
{
    scanf("%ld", &n);
    for (i=1; i<=n; ++i)
    	for (j=1; j<=n; ++j)
		{
        	scanf("%ld",a[i]+j);
			if ( a[i][j]==-1 ) 
			{
				p[nr][0]=i; p[nr++][1]=j;
				a[i][j]= INF;
			}
		}
}

long solve(long X, long Y);

long min_st(long x, long y)
{
	marc[x][y]=1;
	if ( a[x][y] == 0 ) return 0;
    if ( a[x][y] ==INF) return 0;
    if (a[x][y-1]==INF) return min_st(x-1,y)+min_st(x+1,y);
	if ( a[x][y]< a[x][y-1]+a[x-1][y]+a[x+1][y] ) return a[x][y];
	else
    {
//    	marc[x][y]=0;
     	return min_st(x,y-1) + min_st(x-1,y) + min_st(x+1,y);
    }
}

long min_dr(long x, long y)
{
	marc[x][y]=1;
	if ( a[x][y] == 0 ) return 0;
    if ( a[x][y] ==INF) return 0;
    if (a[x][y+1]==INF) return min_dr(x-1,y)+min_dr(x+1,y);
	if ( a[x][y]< a[x][y+1]+a[x-1][y]+a[x+1][y] ) return a[x][y];
	else
    {
//    	marc[x][y]=0;
    	return min_dr(x,y+1) + min_dr(x-1,y) + min_dr(x+1,y);
    }
}

long min_su(long x, long y)
{
	marc[x][y]=1;
	if ( a[x][y] == 0 ) return 0;
    if ( a[x][y] ==INF) return 0;
    if (a[x-1][y]==INF) return min_su(x,y-1)+min_su(x,y+1);
	if ( a[x][y]< a[x-1][y]+a[x][y+1]+a[x][y-1] ) return a[x][y];
	else
    {
//    	marc[x][y]=0;
    	return min_su(x,y-1) + min_su(x,y+1) + min_su(x-1,y);
    }
}

long min_jo(long x, long y)
{
	marc[x][y]=1;
	if ( a[x][y] == 0 ) return 0;
    if ( a[x][y] ==INF) return 0;
    if (a[x+1][y]==INF) return min_jo(x,y-1)+min_jo(x,y+1);
	if ( a[x][y]< a[x][y-1]+a[x+1][y]+a[x][y+1] ) return a[x][y];
	else
    {
//    	marc[x][y]=0;
    	return min_jo(x,y-1) + min_jo(x+1,y) + min_jo(x,y+1);
    }
}




long solve(long X, long Y)
{
	long x=X,y=Y;
	if ( marc[x][y] ) return 0;
	long min1 = min_st(x,y-1)  ;
    long min2 = min_dr(x,y+1)  ;
    long min3 = min_su(x-1,y)  ;
    long min4 = min_jo(x+1,y)  ;
	return min1+min2+min3+min4;
}

int main()
{
	freopen(FIN , "r", stdin);
    freopen(FOUT, "w",stdout);

	nr=0;
	read_data();
	for (i=0; i<nr; ++i)
    {
    	memset(marc,0,sizeof(marc));
		CO+=solve(p[i][0],p[i][1]);
    }
	
	printf("%lld\n",CO);
    fclose(stdin);
    return 0;
}
