// O(N^2) -> greedy prost

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define LMAX 100100
#define NMAX 50100
#define INF 666666666

int i, j, k, N, M, P, niv;
char S[LMAX], stk[LMAX];
int left[LMAX], right[LMAX], sel[NMAX], nel[NMAX];

int num[LMAX];
vector<int> vout[LMAX], eq[LMAX], v[NMAX];
map<int, int> m[NMAX];

void eval(int p1, int p2)
{
	int i, p, q;

	niv = 0;

	//fprintf(stderr, "%d\n", p2);

	for (i = p1; i <= p2; i++)
		if (S[i] == 'B')
		{
			niv++;
			stk[niv] = 'x';
			M++;
			vout[M].clear();
			eq[M].clear();
			vout[M].push_back(M + 1);
			left[niv] = M;
			M++;
			vout[M].clear();
			eq[M].clear();
			right[niv] = M;
		}
		else
		if (S[i] == '(')
		{
			niv++;
			stk[niv] = '(';
		}
		else
		if (S[i] == ')')
		{
			while (stk[niv - 1] != '(')
			{
				if (stk[niv - 1] == 'P')
				{
					eq[left[niv - 2]].push_back(left[niv]);
					eq[left[niv]].push_back(left[niv - 2]);
					eq[right[niv - 2]].push_back(right[niv]);
					eq[right[niv]].push_back(right[niv - 2]);
				}
				else
				if (stk[niv - 1] == 'S')
				{
					eq[right[niv - 2]].push_back(left[niv]);
					eq[left[niv]].push_back(right[niv - 2]);

					right[niv - 2] = right[niv];
				}

				niv -= 2;
			}

			niv--;
			left[niv] = left[niv + 1];
			right[niv] = right[niv + 1];
			stk[niv] = 'x';
		}
		else
		if (S[i] == 'S')
		{
			while (stk[niv - 1] == 'S' || stk[niv - 1] == 'P')
			{
				if (stk[niv - 1] == 'P')
				{
					eq[left[niv - 2]].push_back(left[niv]);
					eq[left[niv]].push_back(left[niv - 2]);
					eq[right[niv - 2]].push_back(right[niv]);
					eq[right[niv]].push_back(right[niv - 2]);
				}
				else
				if (stk[niv - 1] == 'S')
				{
					eq[right[niv - 2]].push_back(left[niv]);
					eq[left[niv]].push_back(right[niv - 2]);

					right[niv - 2] = right[niv];
				}

				niv -= 2;
			}

			niv++;
			stk[niv] = 'S';
		}
		else
		if (S[i] == 'P')
		{
			while (stk[niv - 1] == 'P')
			{
				eq[left[niv - 2]].push_back(left[niv]);
				eq[left[niv]].push_back(left[niv - 2]);
				eq[right[niv - 2]].push_back(right[niv]);
				eq[right[niv]].push_back(right[niv - 2]);

				niv -= 2;
			}

			niv++;
			stk[niv] = 'P';
		}

		if (niv > 1)
			fprintf(stderr, "Bad!\n");
}

void dfnum(int n)
{
	int i;

	num[n] = P;

	for (i = 0; i < eq[n].size(); i++)
		if (num[eq[n][i]] != P)
			dfnum(eq[n][i]);
}

void build_graph(void)
{
	int i, j, p, q;

	P = 0;

	memset(num, 0, sizeof(num));

	for (i = 1; i <= M; i++)
		if (num[i] == 0)
		{
			P++;
			v[P].clear();
			dfnum(i);
		}

	for (i = 1; i <= P; i++)
		m[i].clear();

	for (i = 1; i <= M; i++)
	{
		p = num[i];

		for (j = 0; j < vout[i].size(); j++)
		{
			q = num[vout[i][j]];

			if (!m[p][q])
			{
				m[p][q] = 1;
				v[p].push_back(q);
			}

			if (!m[q][p])
			{
				m[q][p] = 1;
				v[q].push_back(p);
			}
		}
	}
}

int greedyN2(void)
{
	int i, j, p, vmin, count = 0;

	vmin = INF;

	for (p = 1; p <= P; p++)
	{
		sel[p] = 0;
		nel[p] = v[p].size();
	}

	while (1)
	{
		vmin = 0;
		p = 0;

		for (i = 1; i <= P; i++)
			if (nel[i] > vmin && !sel[i])
				vmin = nel[i], p = i;

		/*
		for (i = 1; i <= P; i++)
			if (nel[i] == 1 && !sel[i])
			{
				for (j = 0; j < v[i].size(); j++)
					if (!sel[v[i][j]])
					{
						p = v[i][j];
						break;
					}

				break;
			}
		*/
		
		if (!p)
			break;

		count++;
		sel[p] = 1;
		nel[p] = 0;

		for (i = 0; i < v[p].size(); i++)
			if (!sel[v[p][i]])
				nel[v[p][i]]--;
	}

	return count;
}

int greedyNlogN(void)
{
	return INF;
}

int main()
{
	int i, j, T, vmin;

	freopen("rsp.in", "r", stdin);
	freopen("rsp.out", "w", stdout);

	scanf("%d ", &T);
	while (T--)
	{
		S[0] = '(';
		fgets(S + 1, LMAX - 2, stdin);

		N = strlen(S);
		N--;
		if (S[N] == '\n')
			N--;

		S[++N] = ')';
		M = 0;

		eval(0, N);

		build_graph();
		i = greedyN2();
		printf("%d\n", i);
		fprintf(stderr, "%d\n", i);
	}

	return 0;
}
