#include <stdio.h>
#include <string.h>

#define INF (1 << 29)
#define MAXN 502
#define min(a,b) ((a) < (b) ? (a) : (b))

int N, M, P;
int d[MAXN], uz[MAXN], x[MAXN], C[MAXN][MAXN];

int solve(int src, int dest)
{
	int i, j, min;

	if(src == dest)
		return 0;

	memset(d, 0, sizeof(d)), memset(uz, 0, sizeof(uz));
	uz[src] = 1, d[src] = 0;
	for(i = 1; i <= N; i++)
		d[i] = C[src][i];

	while(1)
	{
		min = INF;
		for(i = 1; i <= N; i++)
		 if(!uz[i] && d[i] < min)
		 	min = d[i], j = i;
		if(min == INF)
			break ;
		for(uz[j] = i = 1; i <= N; i++)
		 if(!uz[i] && d[i] > d[j]+C[j][i])
			d[i] = d[j]+C[j][i];
	}
	return d[dest];
}

int main(void)
{
	int i, j, k, c, last, b1 = 0, b2 = 0;

	freopen("team.in", "rt", stdin);
	freopen("team.out", "wt", stdout);

	scanf("%d\n", &P);

	scanf("%d\n%d\n", &N, &M);
	for(i = 1; i <= N; i++)
	 for(j = 1; j <= N; j++)
		C[i][j] = C[j][i] = INF;

	for(i = 1; i <= M; i++)
	{
		scanf("%d %d %d\n", &j, &k, &c);
		if(C[j][k] > c)
			C[j][k] = C[k][j] = c;
	}
	for(i = 1; i <= P; i++)
		scanf("%d ", &x[i]);

	for(last = i = 1; i <= P; i++)
		b1 += solve(last, x[i]), last = x[i];
	for(last = 1, i = P; i >= 1; i--)
		b2 += solve(last, x[i]), last = x[i];

	printf("%d\n", min(b1, b2));

	return 0;
}


	



