#include <stdio.h>

FILE *f = fopen("becuri.in", "r");
FILE *g = fopen("becuri.out", "w");

long const nmax = 510; //510
long const inf = 1000000;

long n, m;
long a[nmax][nmax], b[nmax][nmax], c[nmax][nmax];
long lin, col, minim;

void citeste();
long maxim(long a, long b);
int caz1();
int caz2();

int main() {
	citeste();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i, j, aux;

	fscanf(f, "%d%d", &n, &m);
	for(i=1; i<=n; i++)
		for(j=1; j<=m; j++) {
			fscanf(f, "%d", &(a[i][j]) );
			b[i][j] = a[i][j];
			c[i][j] = a[i][j];
		}

	minim = inf;

	if( caz1() == 1) {
		aux = maxim(lin, col);
		if( minim > aux ) minim = aux;
	}

	if( caz2() == 1) {
		aux = maxim(lin, col);
		if( minim > aux ) minim = aux;
	}
	if(minim == inf) fprintf(g, "%d\n", -1);
	else fprintf(g, "%d\n", minim);
}

int caz1() {
	long i, j, comp;

	lin = 0;
	col = 0;
	for(i=1; i<=n; i++)
		if( b[i][1] == 1 ) {
			lin++;
			for(j=1; j<=m; j++) b[i][j] = 1 - b[i][j];
		}
	for(j=2; j<=m; j++) {
		comp = b[1][j];
		for(i=2; i<=n; i++) if(b[i][j]!=comp) return 0;
		if(comp == 1) col++;
	}
	if( (col + lin) % 2 == 0) return 1;
	return 0;
}

int caz2() {
	long i, j, comp;

	lin = 0;
	col = 1;
	for(i=1; i<=n; i++) c[i][1] = 1 - c[i][1]; //dimensiunea coloanei = n

	for(i=1; i<=n; i++)
		if( c[i][1] == 1 ) {
			lin++;
			for(j=1; j<=m; j++) c[i][j] = 1 - c[i][j];
		}
	for(j=2; j<=m; j++) {
		comp = c[1][j];
		for(i=2; i<=n; i++) if(c[i][j]!=comp) return 0;
		if(comp == 1) col++;
	}
	if( (col + lin) % 2 == 0) return 1;
	return 0;
}

long maxim(long a, long b) {
	if( a >= b) return a;
	return b;
}
