#include <stdio.h>

#define INF 999999999
#define MAXN 512

void read(void);
void back(int i, int j);
void plus(int i, int j, int nr);
int verify(void);
int numara(int l, int c);

int M, N, A[MAXN][MAXN], min = INF, moves = 0;

int main(void)
{
    int i, j, p, max, nr, lm, cm;

	freopen("becuri.in", "r", stdin);
    freopen("becuri.out", "w", stdout);

    read();

    if (N * M <= 20)
	    back(0, 0);
	else
    {
		min = 0;
    	while (!verify())
        {
			max = 0;

            for (i = 0; i < M; i++)
            	for (j = 0; j < N; j++)
                {
                	nr = numara(i, j);
                    if (nr > max)
                        max = nr, lm = i, cm = j;
                }

			plus(lm, cm, 1);
            min++;
        }
    }

    printf("%d\n", min);

    return 0;
}

void read(void)
{
	int i, j;

	scanf("%d %d", &M, &N);

    for (i = 0; i < M; i++)
    	for (j = 0; j < N; j++)
        	scanf("%d", &A[i][j]);
}

void back(int i, int j)
{
	if (j == N)
    	i++, j = 0;
	if (i == M)
    {
    	if (verify())
			min = min > moves ? moves : min;

        return;
	}

    if (!verify())
    {
        back(i, j + 1);
        plus(i, j, 1);
        moves++;
        back(i, j + 1);
        plus(i, j, -1);
        moves--;
	}
    else
		min = min > moves ? moves : min;
}

void plus(int i, int j, int nr)
{
	int p;

    for (p = 0; p < M; p++)
    	A[p][j] += nr;
	for (p = 0; p < N; p++)
    	A[i][p] += nr;
	A[i][j] -= 2 * nr;
}

int verify(void)
{
	int i, j;

    for (i = 0; i < M; i++)
    	for (j = 0; j < N; j++)
        	if (A[i][j] % 2)
            	return 0;

    return 1;
}

int numara(int l, int c)
{
	int i, nr = 0;

    for (i = 0; i < M; i++)
    	nr += A[i][c];
	for (i = 0; i < N; i++)
    	nr += A[l][i];
	nr -= 2 * A[l][c];

	return nr;
}
