#include<stdio.h>

#define MAXN 502

int n, m;
int a[MAXN][MAXN];
int l[MAXN], c[MAXN];
int left = 0;

void use(int x, int y)
{
   for (int i=0; i<n; ++i)
   {
      a[i][y] = !a[i][y];
      if (a[i][y]) ++left; else --left;
   }
   for (int i=0; i<m; ++i)
   {
      a[x][i] = !a[x][i];
      if (a[x][i]) ++left; else --left;
   }
}

int main(void)
{
   freopen("becuri.in", "rt", stdin);
   freopen("becuri.out", "wt", stdout);

   scanf("%d%d", &n, &m);
   for (int i=0; i<n; ++i)
      for (int j=0; j<m; ++j)
      {
         scanf("%d", &a[i][j]);
         l[i] += a[i][j];
         c[j] += a[i][j];
         left += a[i][j];
      }

   int maxl, maxlp, maxc, maxcp, tot = 0;

   while (left)
   {
      maxl = maxc = 0;
      for (int i=0; i<n; ++i)
         if (l[i] > maxl)
            maxl = l[i], maxlp = i;
      for (int i=0; i<m; ++i)
         if (c[i] >= maxc)
            maxc = c[i], maxcp = i;
      use(maxlp, maxcp);
      ++tot;
   }

   printf("%d\n", tot);
         
   return 0;
}

