//#define _DEBUG1_

#ifdef _DEBUG2_
#define _DEBUG1_
#endif

#include<stdio.h>
#include<stdlib.h>

#include<set>
using namespace std;

#define MAXN 502
#define MAXP 52

#define oo 2000000000
#define MIN(x,y) ((x)<(y)?(x):(y))

int dest[MAXP];
int muc[MAXN*MAXN][3];
int drum[MAXN][MAXN];
int n,m,p;

int *lad[MAXN], *ladc[MAXN];
int gr[MAXN];

struct sv
{
   int val, nod;
   const bool operator < (const sv &b) const
   {
      return (val==b.val) ? (nod<b.nod) : (val<b.val);
   }
};

set<sv> ss;

int d[MAXP][MAXP][MAXP];

int main(void)
{
   freopen("team.in", "rt", stdin);
   freopen("team.out", "wt", stdout);

   scanf("%d%d%d", &p, &n, &m);

   int a, b, c;
   int i;

   for (i=0; i<m; ++i)
   {
      scanf("%d%d%d", &a, &b, &c);
      muc[i][0] = a; muc[i][1] = b; muc[i][2] = c;
      gr[a]++; gr[b]++;
   }

   for (i=1; i<=n; ++i)
      scanf("%d", &dest[i]);

   for (i=1; i<=n; ++i)
      lad[i] = (int *) malloc(sizeof(int) * (gr[i]+1)),
      ladc[i] = (int *) malloc(sizeof(int) * (gr[i]+1)),
      gr[i] = 0;

   for (i=0; i<m; ++i)
   {
      a = muc[i][0]; b = muc[i][1]; c = muc[i][2];
      lad[a][gr[a]] = b;
      ladc[a][gr[a]++] = c;
      lad[b][gr[b]] = a;
      ladc[b][gr[b]++] = c;
   }

   sv t, tt;
   int nc, vc, fiu, fiuc;
   set<sv>::iterator ssi;

   dest[0] = 1;
   for (int q=0; q<=p; ++q)
   {
      ss.erase(ss.begin(), ss.end());
      t.val = 0; t.nod = dest[q];
      ss.insert(t);
      for (i=1; i<=n; ++i)
         drum[q][i] = oo;
      drum[q][dest[q]] = 0;

      while (!ss.empty())
      {
      #ifdef _DEBUG2_
         for (set<sv>::iterator w = ss.begin(); w!=ss.end(); ++w)
            printf("%d %d\n", w->nod, w->val);
         printf("--------------\n");
         fflush(stdout);
      #endif
         t = *ss.begin();
         nc = t.nod; vc = t.val;
         ss.erase(ss.begin());
         for (i=0; i<gr[nc]; ++i)
         {
            fiu = lad[nc][i]; fiuc = ladc[nc][i];
            tt.val = drum[q][fiu]; tt.nod = fiu;
            ssi = ss.find(tt);
            if (ssi!=ss.end())
            {
               if (tt.val > vc + fiuc)
               {
                  ss.erase(ssi);
                  drum[q][fiu] = tt.val = vc+fiuc;
                  ss.insert(tt);
               }
            }
            else if (tt.val > vc + fiuc)
            {
               drum[q][fiu] = tt.val = vc+fiuc;
               ss.insert(tt);
            }
         }
      }

   #ifdef _DEBUG1_
      for (i = 1; i<=n; ++i)
         printf("%d ", drum[q][i]);
      printf("\n");
   #endif
   }

//   memset(d, 1, sizeof(d));
   for (int i=0; i<=p; ++i)
      for (int j=0; j<=p; ++j)
         for (int k=0; k<=p; ++k)
            d[i][j][k] = oo;
   
   for (i=1; i<=p; ++i)
      for (int j=0; j<=p; ++j)
         d[i][i][j] = drum[j][dest[i]];


   for (i=1; i<=p; ++i) // interval length
      for (int j=1; j+i<=p; ++j) // interval start
         for (int l=0; l<=p; ++l) // nod curent
         {
            for (int q=j; q<=j+i; ++q) // pe cine duc acasa
            {
               if (q==j)
                  a=0, b=d[q+1][j+i][q];
               else if (q==j+i)
                  a=d[j][q-1][q], b=0;
               else a=d[j][q-1][q], b=d[q+1][j+i][q];
               
               d[j][i+j][l] = MIN(d[j][i+j][l],
                  drum[l][dest[q]] + a + b);
            }
         }

#ifdef _DEBUG1_
   printf("----\n\n");
   for (int q=0; q<=p; ++q)
   {
      for (int i=1; i<=p; ++i)
      {
         for (int j=1; j<=p; ++j)
            if (d[i][j][q] == oo) printf("* ");
            else printf("%d ", d[i][j][q]);
         printf("\n");
      }
      printf("----\n");
   }
#endif

   printf("%d\n", d[1][p][0]);

   return 0;
}

