#include <cstdio>
#include <cstring>
using namespace std;
#define FIN "team.in"
#define FOUT "team.out"
#define MAX 500

long a[MAX][MAX],p,n,m;
long nr,taxi[MAX+1],dest[MAX];
long min;
long cost;
long d[MAX][MAX], built[MAX];
// in d matrieca drumurilor, in built[x] daca am facut dij(x)


void init(long n) //initializarea matricei costurilor
{
    for (int i=0;i<n;++i)
    {
        for (int j=0; j<n; ++j)a[i][j]=80000;
        a[i][i]=0;
    }
}

void read_data()
{
 	scanf("%ld %ld %ld",&p,&n,&m);
	init(n);

    long x,y,c;
    for (int i=0; i<m; ++i)
    {
		scanf("%ld %ld %ld",&x,&y,&c);
        a[x-1][y-1]=a[y-1][x-1]=c;
    }
	nr=0;
	for (int i=0;i<p;++i)
    {
       	scanf("%ld",&x);
        dest[i]=x-1;
    }
}



void dij(long x, long d[MAX]) //dijkstra
{
 	if ( !built[x] )
    {
		memcpy(d,a+x,sizeof(long)*n);
    	for (int i=0; i<n; ++i)
	    {
    		if ( i==x ) continue;
        	for (int j=0; j<n; ++j)
            	if (a[i][j]+d[i]<d[j]) d[j]=d[i]+a[i][j];
	    }
	    built[x]=1;
	}
}

void go(long act, long T1, long T2) // nodul "act"ual cu taxiul cuprins intre T1 si T2
{
    dij(act,d[act]); //actualizam drumurile daca e nevoie
	// facem minim, mergem in nod respectiv, facem split, urmam taxiurile
    int i,j;
    int min=T1;
    for (i=T1+1; i<T2; ++i)
       	if ( d[act][dest[i]]<d[act][dest[min]] ) min=i;
        
    cost+=d[act][dest[min]];
    
    for (i=T1; i<T2; ++i)
       	if ( dest[i]==dest[min] )
        {
            if ( i>0 )
        	{
            	if( taxi[i-1]==taxi[i] )
                	for (j=i+1;j<p;++j) taxi[j]+= (taxi[j]!=0)?1:0;
            }
            taxi[i]=0;
        }
    j=T1;
    while (!taxi[j] && j<T2) ++j;
    for (i=T1+1; i<=T2; ++i)
        if ( taxi[i]==0 && taxi[j] )
        {
        	if ( i-j>=1 )
            	go(dest[min], j, i);
            j=i+1;
		}
}


int main()
{
	freopen(FIN,"r",stdin);
	freopen(FOUT,"w",stdout);

    read_data();
    memset(built, 0, sizeof(built));
    for (int i=0; i<p; ++i) taxi[i]=1;
    taxi[p]=0;
    go(0,0,p);


    printf("%ld",cost);
    fclose(stdout);
 	return 0;
}

