#include <stdio.h>

#define NMAX 32001

FILE *fin,*fout;

int N,M;
int secv[2*NMAX+1],t,tip;
int *arb1[NMAX+1],*arb2[NMAX+1];
int grad1[NMAX+1],grad2[NMAX+1];
int simil[NMAX+1];
struct lista
{int v;
 lista *leg;
};
struct capl
{int nr,l;
 lista *sp,*ep,*unu;
};

void dfs1(int nod)
{int j;
 for (j=1;j<=grad1[nod];++j)
	 {secv[++t]=1;
	  dfs1(arb1[nod][j]);
	  secv[++t]=-1;
	 }
}

capl dfs2(int nod)
{int j,i;
 capl cap,cap1;
 lista *p;
 cap.sp=cap.ep=cap.unu=NULL;
 cap.nr=cap.l=0;
 if (!grad2[nod]) simil[nod]=1;
 else
	{for (j=1;j<=grad2[nod];++j)
		 {cap1=dfs2(arb2[nod][j]);
		  p=new lista;p->v=1;p->leg=cap1.sp;
		  cap1.sp=p;cap1.nr++;
		  if (cap1.ep==NULL) {cap1.unu=cap1.ep=cap1.sp;}
		  p=new lista;p->v=-1;p->leg=NULL;
		  cap1.ep->leg=p;cap1.ep=p;
		  if (cap.ep)
			 {cap.ep->leg=cap1.sp;
			  cap.ep=cap1.ep;
			 }
		  else cap=cap1;
		 }
	 if (cap.nr<=tip)
		{i=cap.nr+1;p=cap.unu->leg;
		 simil[nod]=cap.nr;
		 while (i<=t&&p)
			   {if (p->v!=secv[i]) break;
				if (p->v>0) simil[nod]++;
				++i;p=p->leg;
			   }
		 i=cap.nr+1;
		 p=cap.unu->leg;
		 if (p&&p->v==1&&i<=t&&secv[i]==1)
		   {++i;cap.nr++;
			while (p->leg&&i<=t&&secv[i]==1&&p->leg->v==1)
				  {p=p->leg;cap.nr++;}
			cap.unu=p;
		   }
		 simil[nod]++;
		}
	 else simil[nod]=tip+1;
	}
 return cap;
}

int main()
{int i,j;
 fin=fopen("arbfind.in","r");
 fscanf(fin,"%d",&N);
 for (i=1;i<=N;++i)
	 {fscanf(fin,"%d",&grad1[i]);
	  arb1[i]=new int[grad1[i]+1];
	  for (j=1;j<=grad1[i];++j)
		  fscanf(fin,"%d",&arb1[i][j]);
	 }
 fscanf(fin,"%d",&M);
 for (i=1;i<=M;++i)
	 {fscanf(fin,"%d",&grad2[i]);
	  arb2[i]=new int[grad2[i]+1];
	  for (j=1;j<=grad2[i];++j)
		  fscanf(fin,"%d",&arb2[i][j]);
	 }
 fclose(fin);
 dfs1(1);
 for (tip=1;tip+1<=t&&secv[tip+1]==1;++tip);
 dfs2(1);
 fout=fopen("arbfind.out","w");
 for (i=1;i<=M;++i)
	 fprintf(fout,"%d\n",simil[i]);
 fclose(fout);
 return 0;
}