#include<stdio.h>
#undef INF
#define INF 100000000
#undef NMAX
#define NMAX 505
FILE *fin,*fout;
int a[NMAX][NMAX],b[NMAX][NMAX],n,m,p,dest[60];
int cost[60][60][NMAX];

inline int min(int x, int y)
  {return (x<y)?x:y;}

void citire() // O(n^2)
  {int i,j,u,v,c;
   fin=fopen("team.in","r");
   fscanf(fin,"%d %d %d",&p,&n,&m);
   for(i=0;i<n;i++)
      for(j=0;j<n;j++)
         if(i==j)
           a[i][j]=b[i][j]=0;
         else
           a[i][j]=b[i][j]=INF;
   for(i=0;i<m;i++)
      {fscanf(fin,"%d %d %d",&u,&v,&c);
       a[u-1][v-1]=b[u-1][v-1]=c;
       a[v-1][u-1]=b[v-1][u-1]=c;}
   for(i=0;i<p;i++)
      {fscanf(fin,"%d",&dest[i]);
       dest[i]--;}
   fclose(fin);}

void roy_floyd() // O(n^3)
  {int i,j,k,man;
   for(k=0;k<n;k++)
      for(i=0;i<n;i++)
         if(i!=k)
          {man=b[i][k];
           for(j=0;j<n;j++)
              if(j!=i && j!=k)
                if(b[i][j]>man+b[k][j])
                  b[i][j]=man+b[k][j];}}

int costul(int i, int j, int k, int mai_verifica) // O(p^2*n^2)
  {int s,count,costmin=INF;
   if(cost[i][j][k]!=-1)
     return cost[i][j][k];
   if(mai_verifica)
     for(count=0;count<n;count++)
        if(count!=k)
          costmin=min(costmin,b[k][count]+costul(i,j,count,0));
   for(s=i;s<=j;s++)
      if(dest[s]==k)
        costmin=min(costmin,costul(i,s-1,k,1)+costul(s+1,j,k,1));
   cost[i][j][k]=costmin;
   return costmin;}


int main()
{
int i,j,k;
citire();
for(i=0;i<=p;i++)
   for(j=0;j<=p;j++)
      for(k=0;k<n;k++)
         if(j<i)
           cost[i][j][k]=0;
         else
           cost[i][j][k]=-1;
roy_floyd();
for(i=0;i<p;i++)
   for(k=0;k<n;k++)
      cost[i][i][k]=b[k][dest[i]];
fout=fopen("team.out","w");
fprintf(fout,"%d\n",costul(0,p-1,0,1));
fclose(fout);
return 0;
}
