#include <cstdio>
#include <cstring>
#include <vector>
#include <cstdlib>

using namespace std;
struct point{
	int x,y;
};

#define infinit 2139062143

point V[8];

int i,j,n,m,k;

int _min[70][70][32];

struct nod{
	int x,y;
	int code;
};


nod heap[70*70*32];
int pos[70][70][32];


int A[70][70];

void readdata(){
	FILE *f=fopen ("gard.in","r");
	fscanf (f,"%d",&n);

	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++){
			fscanf (f,"%d",&A[i][j]);
			if (A[i][j]==-1){
				V[++k].x=i,V[k].y=j;
			}
		}
}

int MIN(int a,int b){
	int ca=(a<=m)?(_min[heap[a].x][heap[a].y][heap[a].code]):(infinit);
	int cb=(b<=m)?(_min[heap[b].x][heap[b].y][heap[b].code]):(infinit);
	if (ca<cb) return a;
	return b;
}

void swap(int x,int y){
	nod aux=heap[x];
	heap[x]=heap[y];
	heap[y]=aux;
	pos[heap[x].x][heap[x].y][heap[x].code]=x;
	pos[heap[y].x][heap[y].y][heap[y].code]=y;
}

void heapup(int i){
	if (i>1){
		if (MIN(i,i/2)==i) swap(i,i/2),heapup(i/2);
	}
}

void heapdown(int i){
	int k=MIN(i*2,i*2+1);
	if (MIN(k,i)!=i) swap(i,k),heapdown(k);
}

const int move[8][2]={{-1,0},{-1,-1},{0,-1},{1,-1},{1,0},{1,1},{0,1},{-1,1}};

#define dx t.x+move[i][0]
#define dy t.y+move[i][1]

int ok(int x,int y){
	if (x>n||y>n) return 0;
	if (x<1||y<1) return 0;
	if (A[x][y]==-1) return 0;
}

#define modbit(a,i) ((a)=(a)^(1<<(i)))

int best;

int djikstra(int x,int y){
	memset(_min,127,sizeof(_min));
	memset(pos,0,sizeof(pos));

	int i,j,p=0;m=0;
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			for (p=0;p<(1<<k);p++){
				m++;
				heap[m].x=i;
				heap[m].y=j;
				heap[m].code=p;
				pos[i][j][p]=m;
			}

	_min[x][y][0]=0;
	heapup(pos[x][y][0]);

	while (m){
		nod t=heap[1];
		if (_min[t.x][t.y][t.code]>=best) break;
		swap(1,m);
		m--;
		heapdown(1);

		for (i=0;i<8;i++)
			if (ok(dx,dy)){
				int ncode=t.code;
				for (j=1;j<=k;j++)
					if (V[j].x>=dx&&V[j].x>=t.x){
						if (V[j].y==dy&&V[j].y==t.y+1) modbit(ncode,j-1);
						if (V[j].y==dy+1&&V[j].y==t.y) modbit(ncode,j-1);
					}
					if (_min[dx][dy][ncode]>_min[t.x][t.y][t.code]+A[dx][dy]){
						_min[dx][dy][ncode]=_min[t.x][t.y][t.code]+A[dx][dy];
						heapup(pos[dx][dy][ncode]);
					}
			}
	}

	return _min[x][y][(1<<k)-1];
}


void solve(){
	int miny=100,minx;
	for (i=1;i<=k;i++)
		if (V[i].y<miny) miny=V[i].y,minx=V[i].x;

	best=infinit;

	for (i=1;i<miny;i++){
		int h=djikstra(minx,i);
		if (h<best) {best=h;
			}
		}

    fprintf (fopen ("gard.out","w"),"%d\n",best);
}


int main()
{
	readdata();
	solve();

	return 0;
}
