#include <stdio.h>

#define MAXN (1 << 21)

typedef long long llong;

int N, M, A, B;
int X[MAXN], Y[MAXN];
int Posmin[MAXN], Posmax[MAXN], Qmin[MAXN], Qmax[MAXN];


llong res;

void solve(void)
{
	int i, x, y, incmin, incmax, sfmin, sfmax, C;

	Qmin[incmin = sfmin = 0] = Y[1], Qmax[incmax = sfmax = 0] = X[1];
	Posmin[0] = Posmax[0] = 1;
	
	for(i = 2; i <= A; i++)
	{
		while(X[i] >= Qmax[sfmax])
		{
			sfmax--;
			if(sfmax < 0) break ;
		}
		Qmax[++sfmax] = X[i], Posmax[sfmax] = i;
		while(Y[i] <= Qmin[sfmin])
		{
			sfmin--;
			if(sfmin < 0) break ;
		}
		Qmin[++sfmin] = Y[i], Posmin[sfmin] = i;
	}
	x = Qmax[incmax], y = Qmin[incmin], C = y-x+1;
	if(C >= B) res += (llong)(C-B+1);

	for(i = A+1; i <= N; i++)
	{
		while(X[i] >= Qmax[sfmax])
		{
			sfmax--;
			if(sfmax < 0) break ;
		}
		Qmax[++sfmax] = X[i], Posmax[sfmax] = i;
		if(incmax > sfmax) incmax = sfmax;

		while(Y[i] <= Qmin[sfmin])
		{
			sfmin--;
			if(sfmin < 0) break ;
		}
		Qmin[++sfmin] = Y[i], Posmin[sfmin] = i;
		if(incmin > sfmin) incmin = sfmin;
		
		while(Posmin[incmin] < i-A+1)
			incmin++;
		while(Posmax[incmax] < i-A+1)
			incmax++;

		x = Qmax[incmax], y = Qmin[incmin], C = y-x+1;
		if(C >= B)
			res += (llong)(C-B+1);
	}
}

void read_data(void)
{
	int i, ind, x, y;
	char c[1024];
	
	scanf("%d %d %d %d\n", &M, &N, &A, &B);

	for(i = 1; i <= N; i++)
	{
		fgets(c, MAXN, stdin), x = 0, y = 0, ind = 0;
		while(c[ind] >= '0' && c[ind] <= '9')
			x = x*10+(c[ind]-'0'), ind++;
		ind++;
		while(c[ind] >= '0' && c[ind] <= '9')
			y = y*10+(c[ind]-'0'), ind++;
		if(y == 0)
			X[i] = M+1, Y[i] = 0;
		else
			X[i] = x, Y[i] = x+y-1;
	}
}

void write_data(void)
{
	printf("%lld\n", res);
}

void ruleaza(void)
{
	read_data();
	if(N >= A)
		solve();
	if(A != B)
	{
		A ^= B, B ^= A, A ^= B;
		if(N >= A)
			solve();
	}
	write_data();
}

int main(void)
{
	freopen("drept.in", "rt", stdin);
	freopen("drept.out", "wt", stdout);

	ruleaza();

	return 0;
}




	



