#include <stdio.h>

FILE *f = fopen("drept.in", "r");
FILE *g = fopen("drept.out", "w");

long const nmax = 2000200; //2000200

struct para {
	long x;
	long indh;
};

long n, m, a, b, nsol;
para p[2][nmax];
long h[2][nmax], nh[2];
long st, plus;

void citeste();
void solve(long a, long b);

int comp(long indh1, long indh2, long tip);
void inter(long indh1, long indh2, long tip);
void adauga(long indp, long tip);
void extrage(long indh, long tip);
void updsus(long indh, long tip);
void updjos(long indh, long tip);

void inord(long indh, long tip);

int main() {
	citeste();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i;

	fscanf(f, "%d%d%d%d", &m, &n, &a, &b);
	for(i=1; i<=n; i++) {
		fscanf(f, "%d%d", &st, &plus);
		p[0][i].x = st;
		p[1][i].x = st + plus - 1;
	}
	//test

	/*adauga(4, 1);
	adauga(3, 1);
	adauga(6, 1);
	adauga(2, 1);
	adauga(1, 1);
	adauga(5, 1);
	inter(1, 3, 1); */
	//inord(1, 0);

	nsol = 0;
	if(a==b) solve(a, b);
	else {
		solve(a, b); //a linii, b coloane
		solve(b, a);
	}
	fprintf(g, "%d\n", nsol);
}

void solve(long a, long b) {
	long i, maxim, c1, c2;

	for(i=1; i<=a; i++) {
		adauga(i, 0);
		adauga(i, 1);
	}
	c1 = p[0][ h[0][1] ].x;
	c2 = p[1][ h[1][1] ].x;
	maxim = c2 - c1 + 1 - b + 1;
	if(maxim > 0) nsol += maxim;

	for(i=a+1; i<=n; i++) {
		extrage( p[0][i-a].indh, 0);
		extrage( p[1][i-a].indh, 1);
		adauga( i, 0);
		adauga( i, 1);

		c1 = p[0][ h[0][1] ].x;
		c2 = p[1][ h[1][1] ].x;
		maxim = c2 - c1 + 1 - b + 1;
		if(maxim > 0) nsol += maxim;
	}
	nh[0] = 0;
	nh[1] = 0;
}

int comp(long indh1, long indh2, long tip) { //0 == ordine naturala. buna
											 //adica 1 este deasupra lui 2
	if(tip==0) {
		if( p[tip][ h[tip][indh1] ].x >= p[tip][ h[tip][indh2] ].x ) return 0;
		return 1;
	}
	else {
		if( p[tip][ h[tip][indh1] ].x <= p[tip][ h[tip][indh2] ].x ) return 0;
		return 1;
	}
}

void inter(long indh1, long indh2, long tip) {
	long aux;

	aux = p[tip] [ h[tip][indh1] ].indh;
	p[tip] [ h[tip][indh1] ].indh = p[tip] [ h[tip][indh2] ].indh;
	p[tip] [ h[tip][indh2] ].indh = aux;

	aux = h[tip][indh1];
	h[tip][indh1] = h[tip][indh2];
	h[tip][indh2] = aux;
}

void adauga(long indp, long tip) {
	nh[tip]++;
	h[tip][ nh[tip] ] = indp;
	p[tip][indp].indh = nh[tip];

	updsus( nh[tip], tip);
}

void extrage(long indh, long tip) {
	long par;

	inter(indh, nh[tip], tip);
	nh[tip]--;

	par = indh / 2;
	if( par > 0 && comp(par, indh, tip) == 1) updsus(indh, tip);
	else updjos(indh, tip);
}

void updsus(long indh, long tip) {
	long par;

	par = indh / 2;
	if( par < 1 || comp(par, indh, tip) == 0) return;
	inter(par, indh, tip);
	updsus(par, tip);
}

void updjos(long indh, long tip) {
	long k;

	k = indh;
	if( 2 * indh <= nh[tip] && comp(k, 2 * indh, tip) == 1 ) k = 2 * indh;
	if( 2 * indh + 1 <= nh[tip] && comp(k, 2 * indh + 1, tip)  == 1 ) k = 2 * indh + 1;
	if( k == indh ) return;
	inter(indh, k, tip);
	updjos(k, tip);
}


void inord(long indh, long tip) {
	if( 2 * indh <= nh[tip] ) inord(2 * indh, tip);
	fprintf(g, "%d\n", h[tip][indh]);
	if( 2 * indh + 1 <= nh[tip] ) inord(2 * indh + 1, tip);
}
