#include <cstdio>
#include <cstdlib>
#include <cstring>

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define CLEAR(X)     memset((X), 0, sizeof((X)))
#define LL           long long

#define NMAX 2000199
//#define NMAX 1024
int N, M, A, B, i, j, k, stp, x;
int b[NMAX], e[NMAX];

int Q1[NMAX], Q2[NMAX], T1[NMAX], T2[NMAX];
int q1b, q1e, q2b, q2e;
LL Ans;

void read(void)
{
    freopen("drept.in", "r", stdin);
    freopen("drept.out", "w", stdout);
    scanf("%d %d %d %d", &M, &N, &A, &B);
    REP(i, N)
    {
        scanf("%d %d", &(b[i]), &(x));
        e[i] = b[i] + x - 1;
    }
}

void solve(void)
{
    register int len, max, min, i, j, q1b, q2b, q1e, q2e;
    q1b = q2b = 0, q1e = q2e = -1;
    REP(i, N)
    {
        for (; q1b <= q1e && i - T1[q1b] >= A; q1b ++);
        for (j = q1e + 1; j > q1b && Q1[j - 1] <= b[i]; j --);
        Q1[j] = b[i], T1[j] = i, q1e = j;
        max = Q1[q1b];
        
        for (; q2b <= q2e && i - T2[q2b] >= A; q2b ++);
        for (j = q2e + 1; j > q2b && Q2[j - 1] >= e[i]; j --);
        Q2[j] = e[i], T2[j] = i, q2e = j;
        min = Q2[q2b];

        if (i + 1 >= A && (len = min - max + 1) >= B)
            Ans += (LL)(len - B + 1);
    }
}

void gen(void)
{
    freopen("drept.in", "w", stdout);
    N = 10, M = 10, A = 1, B = 1;
    printf("%d %d %d %d\n", M, N, A, B);
    REP(i, N)
    {
        int x, y;
        do  x = 1 + rand() % M, y = 1 + rand() % M; while (x > y);
        printf("%d %d\n", x, y - x + 1);
    }
}

int main(void)
{
    read();

    Ans = 0;
    solve();
    A ^= B ^= A ^= B;
    solve();

    printf("%lld\n", Ans);
    return 0;
}
