#include <stdio.h>
#define nmax 36
#define inf 1000000
FILE *fin,*fout;

long n,a[nmax][nmax],ina[nmax][nmax];
long m,x[10],y[10];
long dm[nmax][nmax][nmax][nmax];
long cmin;

long in,sf,cx[10*nmax*nmax],cy[10*nmax*nmax],inc[nmax][nmax];
long dx[8],dy[8];

void detmin(long x,long y)
{
 long i,j,k,l,xc,yc;

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++) { dm[x][y][i][j]=inf; inc[i][j]=0; }

 in=0;
 sf=0;
 cx[0]=x;
 cy[0]=y;
 dm[x][y][x][y]=a[x][y];
 inc[x][y]=1;

 while (in<=sf)
 {
  xc=cx[in];
  yc=cy[in];

  for (i=0;i<8;i++)
  {
   if (!ina[xc+dx[i]][yc+dy[i]] && dm[x][y][xc+dx[i]][yc+dy[i]]>dm[x][y][xc][yc]+a[xc+dx[i]][yc+dy[i]])
  {
   dm[x][y][xc+dx[i]][yc+dy[i]]=dm[x][y][xc][yc]+a[xc+dx[i]][yc+dy[i]];
   if (!inc[xc+dx[i]][yc+dy[i]])
   {
	cx[sf]=xc+dx[i];
	cy[sf]=yc+dy[i];
	sf++;
	inc[xc+dx[i]][yc+dy[i]]=1;
   }
   }
  }
  inc[xc][yc]=0;
  in++;
 }
}
long minim(long x,long y)
{
 if (x<y) return x;
 return y;
}
void solve()
{
 long i,j,k,xmin=0,xmax=0,ymin=0,ymax=0,cc;

 for (i=0;i<m;i++)
 {
  if (x[i]>x[xmax]) xmax=i;
  if (x[i]<x[xmin]) xmin=i;
  if (y[i]>y[ymax]) ymax=i;
  if (y[i]<y[ymin]) ymin=i;
 }

 for (i=1;i<=x[xmax];i++) ina[i][y[xmin]]=1;

 for (i=0;i<=m;i++)
 {
  if (y[i]<=y[xmin]) for (j=y[i];j<=y[xmin];j++) ina[x[i]][j]=1;
  else for (j=y[i];j>=y[xmin];j--) ina[x[i]][j]=1;
 }
 for (i=1;i<=x[xmin]+1;i++) detmin(i,y[xmin]-1);

 cmin=minim(cmin,dm[x[xmin]][y[xmin]-1][x[xmin]][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 cmin=minim(cmin,dm[x[xmin]][y[xmin]-1][x[xmin]-1][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 cmin=minim(cmin,dm[x[xmin]-1][y[xmin]-1][x[xmin]][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 for (i=1;i<=x[xmin]-1;i++)
 {
  for (j=1;j+2<=i;j++)
  {
   cc=dm[i][y[xmin]-1][j][y[xmin]-1];
   for (k=j+1;k<i;k++) cc+=a[k][y[xmin]];
   if (cmin>cc) cmin=cc;
  }

  for (j=i-1;j<=i+1;j++) if (j>=1 && j<=n)
  {
   cmin=minim(cmin,a[i][y[xmin]]+dm[i][y[xmin]-1][j][y[xmin]+1]);
  }

  for (j=i+2;j<=x[xmin]-1;j++)
  {
   cc=dm[i][y[xmin]-1][j][y[xmin]+1];
   for (k=j-1;k>i;k--) cc+=a[k][y[xmin]];
   if (cmin>cc) cmin=cc;
  }
 }
}
void solve2()
{
 long i,j,k,l,xmin=0,xmax=0,ymin=0,ymax=0,cc;
 long xm,ym,dm2=inf,xx,yy,pdc,pdm;

 for (i=0;i<m;i++)
 {
  if (x[i]>x[xmax]) xmax=i;
  if (x[i]<x[xmin]) xmin=i;
  if (y[i]>y[ymax]) ymax=i;
  if (y[i]<y[ymin]) ymin=i;
 }

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++)
 {
  cc=0;
  for (k=0;k<m;k++)
  {
   if (x[k]>i) cc+=x[k]-i;
   else cc+=i-x[k];
   if (y[k]>i) cc+=y[k]-i;
   else cc+=i-y[k];
  }
  pdc=0;
  for (k=0;k<m;k++) if (x[k]!=i && y[k]!=j) pdc++;
  if (cc<dm2 || (cc==dm2 && pdc>pdm) )
  {
   dm2=cc;
   pdm=pdc;
   xm=i;
   ym=i;
  }
 }
 ina[xm][ym]=1;

 for (i=0;i<m;i++)
 {
  xx=xm;
  yy=ym;
  while (xx!=x[i] || yy!=y[i])
  {
   if (xx<x[i])
   {
	if (yy<y[i])
	{
	 ina[xx][yy]=1;
	 ina[xx+1][yy]=1;
	 xx++;
	 yy++;
	}
	else if (yy==y[i])
	{
	 ina[xx][yy]=1;
	 xx++;
	}
	else if (yy>y[i])
	{
	 ina[xx][yy]=1;
	 ina[xx+1][yy]=1;
	 xx++;
	 yy--;
	}
   }
   else if (xx>x[i])
   {
	if (yy<y[i])
	{
	 ina[xx][yy]=1;
	 ina[xx-1][yy]=1;
	 xx--;
	 yy++;
	}
	else if (yy==y[i])
	{
	 ina[xx][yy]=1;
	 xx--;
	}
	else if (yy>y[i])
	{
	 ina[xx][yy]=1;
	 ina[xx-1][yy]=1;
	 xx--;
	 yy--;
	}
   }
   else
   {
	//egal
	if (yy<y[i])
	{
	 ina[xx][yy]=1;
	 yy++;
	}
	else if (yy>y[i])
	{
	 ina[xx][yy]=1;
	 yy--;
	}
   }
  }
 }
 for (i=1;i<=x[xmin];i++) ina[i][y[xmin]]=1;

 for (i=1;i<=x[xmin]+1;i++) detmin(i,y[xmin]-1);

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++) if (ina[i][j])
 {
  for (k=1;k<=n;k++)
  for (l=1;l<=n;l++) dm[i][j][k][l]=inf;
 }

 cmin=minim(cmin,dm[x[xmin]][y[xmin]-1][x[xmin]][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 cmin=minim(cmin,dm[x[xmin]][y[xmin]-1][x[xmin]-1][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 cmin=minim(cmin,dm[x[xmin]-1][y[xmin]-1][x[xmin]][y[xmin]+1]+a[x[xmin]-1][y[xmin]]);

 for (i=1;i<=x[xmin]-1;i++)
 {
  for (j=1;j+2<=i;j++)
  {
   cc=dm[i][y[xmin]-1][j][y[xmin]-1];
   for (k=j+1;k<i;k++) cc+=a[k][y[xmin]];
   if (cmin>cc) cmin=cc;
  }

  for (j=i-1;j<=i+1;j++) if (j>=1 && j<=n)
  {
   cmin=minim(cmin,a[i][y[xmin]]+dm[i][y[xmin]-1][j][y[xmin]+1]);
  }

  for (j=i+2;j<=x[xmin]-1;j++)
  {
   cc=dm[i][y[xmin]-1][j][y[xmin]+1];
   for (k=j-1;k>i;k--) cc+=a[k][y[xmin]];
   if (cmin>cc) cmin=cc;
  }
 }
}

int main()
{
 long i,j;
 fin=fopen("gard.in","rt");
 fout=fopen("gard.out","wt");
 fscanf(fin,"%ld",&n);

 dx[0]=-1; dx[1]=0; dx[2]=+1; dx[3]=0;
 dy[0]=0; dy[1]=1; dy[2]=0; dy[3]=-1;

 dx[4]=-1; dx[5]=1; dx[6]=+1; dx[7]=-1;
 dy[4]=-1; dy[5]=1; dy[6]=-1; dy[7]=+1;

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++)
 {
  fscanf(fin,"%ld",&a[i][j]);
  if (a[i][j]==-1)
  {
   a[i][j]=inf;
   ina[i][j]=1;
   x[m]=i;
   y[m++]=j;
  }
 }
 for (i=0;i<=n+1;i++) { ina[0][i]=1; ina[n+1][i]=1; ina[i][0]=1; ina[i][n+1]=1; }
 cmin=inf;
 solve();

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++) ina[i][j]=0;
 for (i=0;i<m;i++) ina[x[i]][y[i]]=1;
 solve2();

 for (i=0;i<=n+1;i++)
 for (j=0;j<=n+1;j++) ina[i][j]=0;
 for (i=0;i<=n+1;i++) { ina[0][i]=1; ina[n+1][i]=1; ina[i][0]=1; ina[i][n+1]=1; }

 fin=fopen("gard.in","rt");

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++)
 {
  fscanf(fin,"%ld",&a[j][i]);
  if (a[j][i]==-1)
  {
   a[j][i]=inf;
   ina[j][i]=1;
   x[m]=j;
   y[m++]=i;
  }
 }
 solve();

 for (i=1;i<=n;i++)
 for (j=1;j<=n;j++) ina[i][j]=0;
 for (i=0;i<m;i++) ina[x[i]][y[i]]=1;
 solve2();


 fprintf(fout,"%ld\n",cmin);

 fclose(fin);
 fclose(fout);
 return 0;
}
