using namespace std;

#include <cstdio>
#include <cstdlib>

#define FIN  "drept.in"
#define FOUT "drept.out"

#define MAX_N 2000100
#define MAX_M 5000100

int N, M, A, B;
int L[MAX_N], R[MAX_N];
long long ans;

void read()
{
	int i, l;
	char line[32], *p;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d %d %d %d\n", &M, &N, &A, &B);
	if (N <= 500000)
		for (i = 1; i <= N; ++i) {
			fscanf(fi, "%d %d", L+i, &l);
			R[i] = L[i]+l-1;
		}
	else 
		for (i = 1; i <= N; ++i) {
			fgets(line, 32, fi), p = line;
			for (L[i] = 0; '0' <= *p && *p <= '9'; ++p)
				L[i] = L[i]*10+*p-'0';
			for (; !('0' <= *p && *p <= '9'); ++p);
			for (l = 0; '0' <= *p && *p <= '9'; ++p)
				l = l*10+*p-'0';
			R[i] = L[i]+l-1;
	}
	fclose(fi);
}

int mn[MAX_N], mx[MAX_N];

void solve(int A, int B)
{
	int i, mnp, mxp, mns, mxs;
	for (mns = mxs = 0, mnp = mxp = i = 1; i < A; ++i) {
		for (; mns >= mnp && L[mn[mns]] <= L[i]; --mns);
		for (; mxs >= mxp && R[mx[mxs]] >= R[i]; --mxs);
		mn[++mns] = i, mx[++mxs] = i;
	}
	for (i = A; i <= N; ++i) {
		for (; mns >= mnp && L[mn[mns]] <= L[i]; --mns);
		for (; mxs >= mxp && R[mx[mxs]] >= R[i]; --mxs);
		mn[++mns] = i, mx[++mxs] = i;
		if (i-mn[mnp] == A)
			++mnp;
		if (i-mx[mxp] == A)
			++mxp;
		if (R[mx[mxp]]-L[mn[mnp]]+1 >= B)
			ans += R[mx[mxp]]-L[mn[mnp]]-B+2;
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%lld\n", ans);
	fclose(fo);
}

int main()
{
	read();
	solve(A, B);
	if (A != B)
		solve(B, A);
	write();
	return 0;
}
