// O(N)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 200100
#define INF 666666666

int i, j, k, N, niv;
char S[NMAX], stk[NMAX];
int min[NMAX][2][2], rez[2][2];

void eval(int p1, int p2)
{
	int i, p, q;

	niv = 0;

	for (i = p1; i <= p2; i++)
		if (S[i] == 'B')
		{
			niv++;
			stk[niv] = 'x';
			min[niv][0][0] = INF;
			min[niv][0][1] = min[niv][1][0] = 1;
			min[niv][1][1] = 2;
		}
		else
		if (S[i] == '(')
		{
			niv++;
			stk[niv] = '(';
		}
		else
		if (S[i] == ')')
		{
			while (stk[niv - 1] != '(')
			{
				if (stk[niv - 1] == 'P')
				{
					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							if (min[niv][p][q] == INF || min[niv - 2][p][q] == INF)
								rez[p][q] = INF;
							else
								rez[p][q] = min[niv][p][q] + min[niv - 2][p][q] - (p + q);

					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							min[niv - 2][p][q] = rez[p][q];
				}
				else
				if (stk[niv - 1] == 'S')
				{
					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
						{
							rez[p][q] = min[niv - 2][p][0] + min[niv][0][q];

							if (min[niv - 2][p][1] + min[niv][1][q] - 1 < rez[p][q])
								rez[p][q] = min[niv - 2][p][1] + min[niv][1][q] - 1;

							if (rez[p][q] > INF)
								rez[p][q] = INF;
						}

					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							min[niv - 2][p][q] = rez[p][q];
				}

				niv -= 2;
			}

			stk[niv - 1] = 'x';
			for (p = 0; p < 2; p++)
				for (q = 0; q < 2; q++)
					min[niv - 1][p][q] = min[niv][p][q];

			niv--;
		}
		else
		if (S[i] == 'S')
		{
			while (stk[niv - 1] == 'S' || stk[niv - 1] == 'P')
			{
				if (stk[niv - 1] == 'P')
				{
					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							if (min[niv][p][q] == INF || min[niv - 2][p][q] == INF)
								rez[p][q] = INF;
							else
								rez[p][q] = min[niv][p][q] + min[niv - 2][p][q] - (p + q);

					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							min[niv - 2][p][q] = rez[p][q];
				}
				else
				if (stk[niv - 1] == 'S')
				{
					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
						{
							rez[p][q] = min[niv - 2][p][0] + min[niv][0][q];

							if (min[niv - 2][p][1] + min[niv][1][q] - 1 < rez[p][q])
								rez[p][q] = min[niv - 2][p][1] + min[niv][1][q] - 1;

							if (rez[p][q] > INF)
								rez[p][q] = INF;
						}

					for (p = 0; p < 2; p++)
						for (q = 0; q < 2; q++)
							min[niv - 2][p][q] = rez[p][q];
				}

				niv -= 2;
			}

			niv++;
			stk[niv] = 'S';
		}
		else
		if (S[i] == 'P')
		{
			while (stk[niv - 1] == 'P')
			{
				for (p = 0; p < 2; p++)
					for (q = 0; q < 2; q++)
						if (min[niv][p][q] == INF || min[niv - 2][p][q] == INF)
							rez[p][q] = INF;
						else
							rez[p][q] = min[niv][p][q] + min[niv - 2][p][q] - (p + q);

				for (p = 0; p < 2; p++)
					for (q = 0; q < 2; q++)
						min[niv - 2][p][q] = rez[p][q];

				niv -= 2;
			}

			niv++;
			stk[niv] = 'P';
		}

		if (niv != 1)
			fprintf(stderr, "bad!\n");
}

int main()
{
	int i, j, T, vmin;

	freopen("rsp.in", "r", stdin);
	freopen("rsp.out", "w", stdout);

	scanf("%d ", &T);
	while (T--)
	{
		S[0] = '(';
		fgets(S + 1, NMAX - 2, stdin);

		N = strlen(S);
		N--;
		if (S[N] == '\n')
			N--;

		S[++N] = ')';
		eval(0, N);

		vmin = INF;

		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				if (min[1][i][j] < vmin)
					vmin = min[1][i][j];

		printf("%d\n", vmin);
		fprintf(stderr, "%d->%d\n", N + 1, vmin);
	}

	return 0;
}
